function Dialog_Big_Table, TITLE = title, LABEL = label, GROUP_LEADER = group_leader, $
					FONT = font, DATA_ARRAY = data_array, COLOR_ARRAY = color_array, $
					FORMAT=format, COL_HEADERS = col_headers, $
					ROW_HEADERS = row_headers
;
;	dialog popup that gets text from a user (filenames, or directories, usually)
;
;	return = text string, if all went well
;	       = -1 if failed
;
;	inputs:  TITLE = string to put on window base
;            LABEL = string to put over text input window, describing what is sought
;			 GROUP_LEADER = widget id of calling routine, defaults to zero if not present
;			 FONT = font string (e.g., 'Helvetica*24')
;			 DATA_ARRAY = array of data for the table
;			 COLOR_ARRAY = string array of color names
;
;	DPC		20071024	initial code
;
do_title = 1
do_label = 1
if(N_ELEMENTS(TITLE) eq 0) then begin
	do_title = 0
	title=''
endif
if(N_ELEMENTS(LABEL) eq 0) then begin
	do_label = 0
	label = ''
endif
if(N_ELEMENTS(GROUP_LEADER) eq 0) then begin
   group_leader = Widget_Base(Map=0)				; ala Fanning, create an unshown base
   Widget_Control, group_leader, /Realize
   destroy_groupleader = 1
ENDIF ELSE destroy_groupleader = 0
if(N_ELEMENTS(FONT) eq 0) then font=''
if(N_ELEMENTS(DATA_ARRAY) eq 0) then begin
	print, "ERROR - Table has no data -- returning"
	RETURN, -1L
endif
if(N_ELEMENTS(COLOR_ARRAY) eq 0) then begin
	color_array = 'gray'
endif
d_size = SIZE(data_array)
nc = d_size[1]
nr = d_size[2]
if(N_ELEMENTS(COL_HEADERS) eq 0) then begin
	col_headers = strarr(nc)
	col_headers[*] = ''
endif
if(N_ELEMENTS(ROW_HEADERS) eq 0) then begin
	row_headers = strarr(nr)
	row_headers[*] = ''
endif
if(N_ELEMENTS(FORMAT) eq 0) then begin
	i_format = 0
	format=''
endif else begin
	i_format=1
endelse
;
;print, "in dialog_big_table, iformat = ",i_format
;help, format
;
;     create a heap variable structure and pointer to pass to the
;     pop up widget
;
w_ptr = PTR_NEW()
wStruct = {ptr: w_ptr, label_wid: -1L, table_wid: -1L, title_wid: -1L, $
			widget_wid: -1L,  $
			;scr_xsize: scr_xsize, scr_ysize: scr_ysize, $
			;xsize: xsize, ysize: ysize, x_scroll_size: x_scroll_size, $
			;y_scroll_size: y_scroll_size, $
			do_title: do_title, do_label: do_label, title: title, label: label, font: font, $
			data_array: data_array, i_format: i_format, format: format, $
			col_headers: col_headers, row_headers: row_headers, $
			revised_data_array: data_array, color_array: color_array}
;
DTW_ptr = PTR_NEW(wStruct)		; make the heap variable and pointer
;
DTW_struct_ptr = {ptr: DTW_ptr}	; make a new structure that holds the pointer
;
;   call the pop up, passing the pointer
;
Dialog_Big_Table_Window, GROUP_LEADER=group_leader, _EXTRA = DTW_struct_ptr
;
DTW_ptr = DTW_struct_ptr.ptr
;
; load table value as return variable
;
;text_string = (*DTW_ptr).text_string
;
;
revised_data_array = (*DTW_ptr).revised_data_array
;
PTR_FREE, DTW_ptr
PTR_FREE, w_ptr
if(destroy_groupleader) then WIDGET_CONTROL, group_leader, /DESTROY
;
;if(N_ELEMENTS(text_string) ne 0) then RETURN, text_string else RETURN, -1L
;
RETURN, revised_data_array
;
end


