pro MSP_BDP_Camera_Classify, Event, camera_name
	;
	;	classify camera as:
	;
	;	F5, F17, or PV
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	s_ptr = PTR_struct.PTR_summary
	f_ptr = PTR_struct.PTR_FITS
	n_ptr = PTR_struct.PTR_night
	;
	object = STRUPCASE( STRTRIM( (*f_ptr).object,2 ))
	comment1 = STRUPCASE( STRTRIM( (*f_ptr).comment[0],2 ))
	comment2 = STRUPCASE( STRTRIM( (*f_ptr).comment[1],2 ))
	;
	obcc = object+comment1+comment2
	;
	if( STRPOS( obcc, "F5") ge 0 or STRPOS( obcc, "F/5") ge 0) then F5 = 1 else F5 = 0
	if( STRPOS( obcc, "F17") ge 0 or STRPOS( obcc, "F/17") ge 0) then F17 = 1 else F17 = 0
	if( STRPOS( obcc, "PV")  ge 0 or STRPOS( obcc, "PUPIL") ge 0) then $
					PV = 1 else PV = 0
	;
	camera_name = ''
	if(F17 and NOT(F5) and NOT(PV)) then camera_name = "F17"
	if(PV and NOT(F17) and NOT(F5)) then camera_name = "PV"
	if(camera_name eq '') then begin
		camera_name = "F5"			; default
		default = 1
	endif else default = 0
	;
	;	if the header is 2010+, examine camera steps to verify selection
	;
	if( (*f_ptr).header_version gt 0) then begin
		this_camera_step = (*f_ptr).camera_pos
		camera_names = ['F5', 'F17', 'PV']
		camera_step = [-568L, -11661L, -22046L]
		cam_dif = abs(camera_step - this_camera_step)
		cam_min = MIN(cam_dif, ind_cam)
		this_camera_name = camera_names[ind_cam]
		;
		if(default eq 1) then begin
			camera_name = this_camera_name
		endif else begin
			if(camera_name ne this_camera_name) then begin
				MSP_BDP_print_text, Event, "WARNING - camera name in comments does not match camera motor steps"
				MSP_BDP_print_text, Event, "  Camera name from comments = " + camera_name
				MSP_BDP_print_text, Event, "  Camera name from motor steps = " + this_camera_name
				MSP_BDP_print_text, Event, "  Using name from motor steps"
				camera_name = this_camera_name
			endif
		endelse
	endif
	;
end
