;
;	Part 2 Event Handler Routines - read images, parse headers, classify into groups
;
;-----------------------------------------------------------------
pro P2_Select_Night, Event
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE = PTR_struct
	n_ptr = PTR_struct.PTR_night
	s_ptr = PTR_struct.PTR_summary
	;
	wid = WIDGET_INFO(Event.top, FIND_BY_UNAME="P2_Droplist_Night")
	;
	night_index = Event.index
	;
	;print, "in droplist, index = ",night_index
	;
	(*PTR_struct.PTR_night).night_desig = (*PTR_struct.PTR_summary).night_date[night_index]
	;
	;	clear the CDS and RAW1 directory OK flags, since they haven't yet been checked
	;
	(*n_ptr).cds_ok = 0
	(*n_ptr).paths_cds_root[0] = ''
	(*n_ptr).raw1_ok = 0
	(*n_ptr).paths_raw1_root[0] = ''
	;
	new_night = STRING(format='(I8.8)',(*PTR_struct.PTR_night).night_desig)
	;
	;	reset buttons and LEDs
	;
	for iw = 0, N_ELEMENTS( (*s_ptr).P2_button_wid)-1 do begin
		if(iw le 1) then sense = 1 else sense = 0
		P2_button_sensitize, Event, iw, sense
	endfor
	;
	for iw = 0, N_ELEMENTS( (*s_ptr).P2_LED_wid)-1 do begin
		if(iw le 0) then sense = 1 else sense = 0
		P2_LED_sensitize, Event, iw, sense
	endfor
	;
	MSP_BDP_print_text, Event, "Night "+new_night+" selected"
	;
end
;
;----------------------------------------------------------------
pro P2_Open_Existing_Night_Summaries, Event
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	n_ptr = PTR_struct.PTR_night
	;
	;
	sense = 1
;	for i_P2 = 4, 9 do begin
;		P2_button_sensitize, Event, i_P2, sense
;	endfor
	;
	i_LED = 3
	P2_LED_sensitize, Event, i_LED, sense
	;
	;	turn off others
	;
	P2_LED_sensitize, Event, 0, 0
	P2_LED_sensitize, Event, 1, 0
	P2_LED_sensitize, Event, 2, 0
	P2_button_sensitize, Event, 2, 0
	P2_button_sensitize, Event, 3, 0
	;
	;	check that a night has been selected
	;
	night_desig = (*n_ptr).night_desig
	if( night_desig eq 0L) then begin
		MSP_BDP_print_text, Event, "ERROR - No Night Selected. Please Select a Night"
		goto, P2_BOENSA_end
	endif
	;
	;	go get the night file
	;
	MSP_BDP_Create_Night_File_Path, Event, night_desig, night_file_path
	MSP_BDP_print_text, Event, "Trying to Restore Night File = "+night_file_path
	MSP_BDP_Restore_Night_File, Event, night_file_path, description, ierr
	if(ierr ne 0) then goto, P2_BOENSA_end
	;
	;	get the pointers anew
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	;print, "after return to event handler, num_images = ",(*PTR_struct.PTR_night).num_images
	MSP_BDP_print_text, Event, "Restored Night File = "+night_file_path
	MSP_BDP_print_text, Event, "  with embedded description = "+description
	;
	;	if the reload contained the following, turn on some LEDs and buttons
	;
	;	A.valid directories for the night
	;
	n_ptr = PTR_struct.PTR_night
	s_ptr = PTR_struct.PTR_summary
	;
	num_images = (*n_ptr).num_images
	num_groups = (*n_ptr).num_groups
	;
	if((*n_ptr).cds_ok ne 0 and (*n_ptr).raw1_ok ne 0) then begin
		P2_LED_sensitize, Event, 0, 1
		colors = ["green", "green"]
		WCT_LED_stack, (*s_ptr).P2_LED_wid[0], colors
		;
		P2_button_sensitize, Event, 2, 1
	endif
	;
	;	B. image list is not empty
	;
	if( num_images ne 0) then begin
		P2_LED_sensitize, Event, 1, 1
		colors = ["green"]
		WCT_LED_stack, (*s_ptr).P2_LED_wid[1], colors
		;
		P2_button_sensitize, Event, 3, 1
	endif
	;
	;	C. image list has been read in
	;
	if( (*n_ptr).image_name[0] ne '' and (*n_ptr).image_name[num_images-1] ne '') then begin
		P2_LED_sensitize, Event, 2, 1
		colors = strarr(25)
		if(num_images ge 25) then begin
			colors[*] = "green"
		endif else begin
			colors[0:num_images-1] = "green"
			colors[num_images:24] = "orange"
		endelse
		WCT_LED_stack, (*s_ptr).P2_LED_wid[2], colors
		;
		P2_button_sensitize, Event, 4, 1
		P2_button_sensitize, Event, 5, 1		; allow edits
		P2_button_sensitize, Event, 7, 1		; and saves
	endif
	;
	;	D. groups were already formed
	;
	if( num_groups ne 0) then begin
		P2_LED_sensitize, Event, 3, 1
		colors = strarr(25)
		if(num_groups ge 25) then begin
			colors[*] = "green"
		endif else begin
			colors[0:num_groups-1] = "green"
			colors[num_groups:24] = "orange"
		endelse
		WCT_LED_stack, (*s_ptr).P2_LED_wid[3], colors
		;
		P2_button_sensitize, Event, 6, 1		; allow edits
	endif

	;
	P2_BOENSA_end:
end
;
;-----------------------------------------------------------------
pro P2_Perform_Directory_Check, Event
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	n_ptr = PTR_struct.PTR_night
	s_ptr = PTR_struct.PTR_summary
	;
	;	turn on first LED pair
	;
	sense = 1
	P2_LED_sensitize, Event, 0, sense
	;
	;	check that a night has been selected
	;
	if( (*n_ptr).night_desig eq 0L) then begin
		MSP_BDP_print_text, Event, "ERROR - No Night Selected. Please Select a Night"
		goto, P2_BPDCA_end
	endif
	;
	;	go to the raw data directory and look for subdirectories
	;	named "CDS_RAW" and "RAW1_RAW"  -- if present, set flags
	;	if not, clear flags and write error message
	;
	raw_root = (*s_ptr).root_raw
	;
	night_name = STRING(format='(I8.8)',(*n_ptr).night_desig)
	CDS_test = fix_path( FILEPATH("CDS_RAW", ROOT_DIR = raw_root, SUBDIRECTORY = night_name) + PATH_SEP() )
	RAW1_test = fix_path( FILEPATH("RAW1_RAW", ROOT_DIR = raw_root, SUBDIRECTORY = night_name) + PATH_SEP() )
	;
	;print, "looking for ",CDS_test," and ",RAW1_test
	;
	CDS_struct = FILE_INFO(CDS_test)
	RAW1_struct = FILE_INFO(RAW1_test)
	;
	;print, "CDS_struct = ",CDS_struct
	;print, "RAW1_struct = ",RAW1_struct
	;
	;	set group count to zero
	;
	(*n_ptr).num_groups = 0
	;
	;	check that contents are not empty
	;
	colors = strarr(2)
	;
	if( NOT(CDS_struct.directory) ) then begin
		(*n_ptr).cds_ok = 0
		colors[0] = "red"
		MSP_BDP_print_text, Event, "ERROR - CDS_RAW subdirectory not present"
	endif else begin
		;
		;	test for directory being empty
		;
		result = FILE_SEARCH(CDS_test,'*',COUNT=count)
		if(count ne 0) then begin
			(*n_ptr).cds_ok = 1
			colors[0] = "green"
			MSP_BDP_print_text, Event, "Located non-empty subdirectory "+CDS_test
		endif else begin
			(*n_ptr).cds_ok = -1					; directory there, but empty
			colors[0] = "yellow"
			MSP_BDP_print_text, Event, "WARNING - CDS_RAW subdirectory is empty"
		endelse
	;	(*n_ptr).paths_cds_root[0] = CDS_test	; deprecated 20100608
		(*n_ptr).paths_cds_root[0] = fix_path( night_name + PATH_SEP() + "CDS_RAW" + PATH_SEP() )
	endelse
	;
	if( NOT(RAW1_struct.directory) ) then begin
		(*n_ptr).raw1_ok = 0
		colors[1] = "red"
		MSP_BDP_print_text, Event, "ERROR - RAW1_RAW subdirectory not present"
	endif else begin
		result = FILE_SEARCH(RAW1_test,'*',COUNT=count)
		if(count ne 0) then begin
			(*n_ptr).raw1_ok = 1
			colors[1] = "green"
			MSP_BDP_print_text, Event, "Located non-empty subdirectory "+RAW1_test
		endif else begin
			(*n_ptr).raw1_ok = -1
			colors[1] = "yellow"
			MSP_BDP_print_text, Event, "WARNING - RAW1_RAW subdirectory is empty"
		endelse
;		(*n_ptr).paths_raw1_root[0] = RAW1_test	; deprecated 20100608
		(*n_ptr).paths_raw1_root[0] = FIX_PATH( night_name + PATH_SEP() + "RAW1_RAW" + PATH_SEP() )
	endelse
	;
	;	OK, turn on next button
	;
	sense = 1
	P2_button_sensitize, Event, 2, sense
	sense = 0
	;
	for i_P2 = 3, 7 do begin
		P2_button_sensitize, Event, i_P2, sense
	endfor
	;
	;	update LEDs
	;
	WCT_LED_stack, (*s_ptr).P2_LED_wid[0], colors
	;
	P2_BPDCA_end:
end
;
;-----------------------------------------------------------------
pro P2_Read_Directory_for_Image_List, Event
	;
	;	reads the CDS_RAW directory for filenames
	;
	;	note that this read is of the most raw (lowest level in the
	;	path name heirarchy) images. Don't use this to rebuild an image
	;	list of partially reduced data.
	;
	;	also performs sort by numeric (not alphabetic) scan order
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	n_ptr = PTR_struct.PTR_night
	s_ptr = PTR_struct.PTR_summary
	;
	;	enable LED
	;
	sense = 1
	P2_LED_sensitize, Event, 1, sense
	;
	;	first, check that we have a CDS_OK flag asserted correctly
	;
	colors = ["red"]
	;
	if( (*n_ptr).cds_ok ne 1) then begin
		if( (*n_ptr).cds_ok eq -1) then begin
			MSP_BDP_print_text, Event, "ERROR - No images in CDS_RAW subdirectory"
			goto, P2_RDIL_end
		endif else begin
			MSP_BDP_print_text, Event, "ERROR - No CDS_RAW directory found"
			goto, P2_RDIL_end
		endelse
	endif
	;
	;	build raw image list from search for all FITS files in the CDS directory
	;
	CDS_dir = fix_path( (*s_ptr).root_raw + PATH_SEP() + (*n_ptr).paths_cds_root[0] )
	;
	directory_list = FILE_SEARCH(CDS_dir,"*.fits",COUNT=count)
	;
	if(count eq 0) then begin
		MSP_BDP_print_text, Event, "Directory "+CDS_dir+" has no FITS images. Skipping..."
		goto, P2_RDIL_end
	endif
	;
	file_list = FILE_BASENAME(directory_list, ".FITS", /FOLD_CASE)
	;
	image_list = lonarr(count)
	;
	for i_i = 0, count-1 do begin
		parts = STRSPLIT( file_list[i_i],'.',/EXTRACT,COUNT=s_count)
		reads, parts[1], format='(i)', sequence_no
		image_list[i_i] = sequence_no
	endfor
	;
	;	sort
	;
	ind = SORT(image_list)
	;
	;	and reorder
	;
	max_image = N_ELEMENTS( (*n_ptr).image_list)
	(*n_ptr).image_list[0:count-1] = image_list[ind]	; image numbers, without YYYYMMDD names attached
	(*n_ptr).image_list[count:max_image - 1] = 99999
	;
	(*n_ptr).num_images = count
	(*n_ptr).image_name[0:count-1] = file_list[ind]		; image names, without directory paths attached
	(*n_ptr).image_name[count:max_image - 1] = ''
	;
	(*n_ptr).image_root_index[0:count-1] = 0L			; point to first set of CDS, RAW1 path rootnames
	(*n_ptr).image_root_index[count:max_image - 1] = -1L
	;
	colors = ["green"]
	;
	MSP_BDP_print_text, Event, "Read image list consisting of "+STRING(format='(i4)',count)+" images"
	;
	;	turn on next button
	;
	sense = 1
	P2_button_sensitize, Event, 3, sense
	;
	P2_RDIL_end:
	;
	WCT_LED_stack, (*s_ptr).P2_LED_wid[1], colors
	;
end
;
;-----------------------------------------------------------------
pro P2_Build_Image_Log, Event
	;
	;	checks file quality and reads/parses FITS headers
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	s_ptr = PTR_struct.PTR_summary
	n_ptr = PTR_struct.PTR_night
	f_ptr = PTR_struct.PTR_FITS
	;
	;	turn on LED stack
	;
	sense = 1
	P2_LED_sensitize, Event, 2, sense
	;
	root_raw = fix_path((*s_ptr).root_raw)
	night_desig = (*n_ptr).night_desig
	night_dir = STRING(format='(i8.8)',night_desig)
	;
	;	How many images and how many per LED "light" in the progress stack?
	;
	n_image = (*n_ptr).num_images
	image_name = (*n_ptr).image_name[0:n_image-1]
	;
	n_LED = 25
	if(n_image gt n_LED*1.5) then n_per_LED = ROUND(n_image / float(n_LED)) else n_per_LED = 1
	;
	;	clear the LED string to orange to signify the start
	;
	colors = strarr(n_LED)
	colors[*] = "orange"
	LED_wid = (*s_ptr).P2_LED_wid[2]
	WCT_LED_stack, LED_wid, colors
	;
	;	for each image
	;
	for i_image = 0, n_image-1 do begin
		;
		;	clear the information for the image
		;
		(*n_ptr).image_type[i_image] = ''
		(*n_ptr).image_object[i_image] = ''
		(*n_ptr).image_filter[i_image] = ''
		(*n_ptr).image_exptime[i_image] = 0.0
		(*n_ptr).image_HWP_angle[i_image] = 0.0
		(*n_ptr).image_ski_jump[i_image] = 99
		(*n_ptr).image_frame[i_image] = 'NC x NR'
		(*n_ptr).image_camera[i_image] = '?'
		(*n_ptr).image_readout_mode[i_image] = 0
		(*n_ptr).image_comment[i_image] = ''
		(*n_ptr).image_root_index[i_image] = 0L
		;
		(*n_ptr).image_coadds[i_image] = 1
		;
		current_LED = (0 > ROUND(i_image / float(n_per_LED))) < (n_LED - 1)
		;
		;	set flag to store FITS header
		;
		save_FITS = 1
		;
		;	check that CDS and RAW images exist and have non-zero sizes
		;
		CDS_root = (*s_ptr).root_raw + (*n_ptr).paths_cds_root[0]
		CDS_pathname = fix_path( FILEPATH(image_name[i_image], ROOT_DIR=CDS_root) )
		;
		;CDS_pathname = FILEPATH(image_name[i_image],ROOT_DIR=root_raw,$
		;				SUBDIRECTORY=[night_dir,'CDS_RAW'])
		CDS_pathname = CDS_pathname + ".fits"
		parts = STRSPLIT(image_name[i_image], '.', /EXTRACT)
		;
		RAW1_root = (*s_ptr).root_raw + (*n_ptr).paths_raw1_root[0]
		RAW1_pathname = fix_path( FILEPATH("raw1_"+parts[1],ROOT_DIR=RAW1_root))
		;
		;	get sizes
		;
		CDS_info = FILE_INFO(CDS_pathname)
		RAW1_info = FILE_INFO(RAW1_pathname)
		;
		if( NOT(CDS_info.exists) ) then begin
			save_FITS = 0
			MSP_BDP_print_text, Event, "ERROR - file "+CDS_pathname+" does not exist - skipping"
		endif
		if( NOT(RAW1_info.exists) ) then begin
			save_FITS = 0
			MSP_BDP_print_text, Event, "ERROR - file "+RAW1_pathname+" does not exist - skipping"
		endif
		if(save_FITS eq 0) then goto, loop_end
		if(CDS_info.size lt 2000L) then begin
			save_FITS = 0
			MSP_BDP_print_text, Event, "ERROR - file "+CDS_pathname+" is empty or corrupted - skipping"
		endif
		if(RAW1_info.size lt 2000L) then begin
			save_FITS = 0
			MSP_BDP_print_text, Event, "ERROR - file "+RAW1_pathname+" is empty or corrupted - skipping"
		endif
		if(save_FITS eq 0) then begin
			(*n_ptr).image_type[i_image] = '**BAD**'
			(*n_ptr).image_object[i_image] = 'ERROR-File Empty'
			goto, loop_end
		endif
		;
		;	if got to here, change current LED color to yellow
		;
		colors[current_LED] = "yellow"
		WCT_LED_stack, LED_wid, colors
		;
		;	read the FITS header into the structure
		;
		raw_header = strarr(300)
		raw_header = HEADFITS( CDS_pathname, /SILENT)
		;
		max_header = N_ELEMENTS( (*s_ptr).raw_header )
		header_lines = max_header < N_ELEMENTS(raw_header)
		if(header_lines ne 0) then begin
			(*s_ptr).raw_header[0:header_lines-1] = raw_header[0:header_lines-1]
			(*s_ptr).raw_header[header_lines:max_header - 1] = ''
		endif else begin
			save_FITS = 0
			MSP_BDP_print_text, Event, "ERROR - file "+CDS_pathname+" has no FITS header -- skipping
			goto, loop_end
		endelse
		;
		;	parse the FITS header
		;
		MSP_BDP_Parse_FITS_Header, Event
		;
		;	if we recovered the file name from the FITS file, set color of LED to blue
		;
		if ( (*f_ptr).raw_filename ne '') then begin
			colors[current_LED] = "blue"
			WCT_LED_stack, LED_wid, colors
		endif else begin
			save_FITS = 0
			MSP_BDP_print_text, Event, "ERROR - could not parse FITS header for file "+CDS_pathname+" -- skipping"
			goto, loop_end
		endelse
		;
		(*n_ptr).image_exptime[i_image] = (*f_ptr).exptime
		;
		;	OK, header looks good. Read image and perform fast triage
		;
		image = readfits( CDS_pathname, header, /SILENT)
		;
		;	don't do triage if not a CDS type image
		;
		if( (*f_ptr).CDS eq 1) then begin
			;
			;	capture coadd number, if available
			;
			ncoadds = (*f_ptr).numcoadds
			;
			MSP_BDP_Triage, image, NCOADD=ncoadds, triage_code, triage_message
			;
			;	if Triage found any error, save it and put the message into the image comment line
			;
			if(triage_code ne 0) then begin
				;
				;	load night summary information
				;
				(*n_ptr).image_comment[i_image] = triage_message
				(*n_ptr).image_type[i_image] = "**BAD**"
				(*n_ptr).image_ski_jump[i_image] = triage_code * 100
			endif else begin
				;
				;	if no triage error, classify sky jump(s)
				;
				MSP_BDP_Ski_Jump_Detector, image, ski_jump_code
				;
				(*n_ptr).image_ski_jump[i_image] = ski_jump_code
			endelse
		endif else begin
			MSP_BDP_print_text, Event, "Error - Not CDS image -- skipping"
			;
			; TBD
			;
		endelse
		;
		;	if got to here, set LED color to violet
		;
		colors[current_LED] = "violet"
		WCT_LED_stack, LED_wid, colors
		;
		;	load key header values into night summary
		;
		(*n_ptr).image_object[i_image] = (*f_ptr).object
		;
		;   and classify filters, type of observation
		;
		;	20101124 - classify camera, first, as we need to know camera to resolve some filter selections
		;
		MSP_BDP_Camera_Classify, Event, camera_name
		(*n_ptr).image_camera[i_image] = camera_name
		;
		MSP_BDP_Filter_Classify, Event, camera_name, filter_summary_name
		(*n_ptr).image_filter[i_image] = filter_summary_name
		;
		MSP_BDP_Observation_Classify, Event, filter_summary_name, observation_summary_name
		if( (*n_ptr).image_type[i_image] ne "**BAD**" and (*n_ptr).image_type[i_image] ne 'Skip') then $
			(*n_ptr).image_type[i_image] = observation_summary_name
		;
		;MSP_BDP_Camera_Classify, Event, camera_name
		;(*n_ptr).image_camera[i_image] = camera_name
		;
		;	copy the remaining items into the nightly summary
		;
		(*n_ptr).image_readout_mode[i_image] = 1	; until we know better
		;
		;	number of coadds
		;
		(*n_ptr).image_coadds[i_image] = (*f_ptr).numcoadds
		;
		;	if comment buffer empty, string together FITS comments
		;
		if( (*n_ptr).image_comment[i_image] eq '') then begin
			(*n_ptr).image_comment[i_image] = STRTRIM( (*f_ptr).comment[0], 2) + ';' + $
			                   STRTRIM( (*f_ptr).comment[1], 2)
		endif
		;
		if( STRPOS( STRUPCASE( (*n_ptr).image_type[i_image]),"POL") ge 0 $
		   or STRPOS( STRUPCASE( (*n_ptr).image_type[i_image]),"P-FLAT") ge 0) then begin
			MSP_BDP_Parse_HWP_Angle, Event, angle
			(*n_ptr).image_HWP_angle[i_image] = angle
		endif else (*n_ptr).image_HWP_angle[i_image] = 0.0
		;
		;	get the sub or full frame designation
		;
		nc = (*f_ptr).naxis1
		nr = (*f_ptr).naxis2
		if(nc eq 1024 and nr eq 1026) then begin
			(*n_ptr).image_frame[i_image] = 'Full'
		endif else begin
			nc_text = STRTRIM(STRING(format='(i)',nc),2)
			nr_text = STRTRIM(STRING(format='(i)',nr),2)
			(*n_ptr).image_frame[i_image] = nc_text+"x"+nr_text
		endelse
		;
		;	load this image's FITS header into the buffer
		;
		(*n_ptr).header_list[i_image] = (*f_ptr)
		;
		;	and set the color of the LED to green
		;
		colors[current_LED] = "green"
		WCT_LED_stack, LED_wid, colors
		;
		MSP_BDP_print_text, Event, "Read in image " + FILE_BASENAME(CDS_pathname)
		;
		loop_end:
	endfor
	;
	;	save the night summary to disk as an IDL sav file
	;
	MSP_BDP_Create_Night_File_Path, Event, night_desig, night_file_path
    ;
	MSP_BDP_Save_Night_File, Event, night_file_path
	;
	MSP_BDP_print_text, Event, "Saved Night File = "+night_file_path
	;
	;	turn on next button, as well as edit and print buttons
	;
	sense = 1
	P2_button_sensitize, Event, 4, sense
	P2_button_sensitize, Event, 5, sense
	P2_button_sensitize, Event, 7, sense
	;P2_button_sensitize, Event, 8, sense
	;
end
;
;-----------------------------------------------------------------
pro P2_Group_Images, Event
	;
	;	builts groups from image table
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	s_ptr = PTR_struct.PTR_summary
	n_ptr = PTR_struct.PTR_night
	f_ptr = PTR_struct.PTR_FITS
	;
	;	clear the group structures in the night table
	;
	max_groups = (*n_ptr).max_groups
	;
	for i_g = 0, max_groups-1 do begin
		(*n_ptr).groups[i_g].group_id = 0
        (*n_ptr).groups[i_g].group_images = 0
        (*n_ptr).groups[i_g].group_start = 0
        (*n_ptr).groups[i_g].group_end = 0
        (*n_ptr).groups[i_g].group_list[*] = 0
        (*n_ptr).groups[i_g].group_object = ''
        (*n_ptr).groups[i_g].group_type = ''
        (*n_ptr).groups[i_g].group_filter = ''
        (*n_ptr).groups[i_g].group_exptime = 0.0
        (*n_ptr).groups[i_g].group_frame = ''
        (*n_ptr).groups[i_g].group_readout_mode = 0
        (*n_ptr).groups[i_g].group_camera = ''
        ;
        (*n_ptr).groups[i_g].group_coadds = 1
    endfor
	;
	;	create some working space and pointers to it
	;
	n_images = (*n_ptr).num_images
	image_group_list = intarr(2,n_images)
	g_struct = {group_no: 			0, $
				n_images: 			n_images, $
				start_image: 		0, $
				image_index: 		0, $
				open_flag: 			0, $
				image_group_list: 	image_group_list}
	g_ptr = PTR_NEW(g_struct)
	;
	;	load all known image numbers into structure's list
	;
	(*g_ptr).image_group_list[0,*] = (*n_ptr).image_list[0:n_images-1]
	;
	;	set all images with "**BAD**" image types or ski jumps not equal to "11" (and not
	;		lights-on linearity) to group # -1
	;
	ind = WHERE( (*n_ptr).image_type[0:n_images-1] eq "**BAD**" or (*n_ptr).image_type[0:n_images-1] eq 'Skip',count)
	if(count ne 0) then begin
		(*g_ptr).image_group_list[1,ind] = -1
	endif
	ind = WHERE( ( (*n_ptr).image_ski_jump[0:n_images-1] ne 11) and $
			(STRPOS( (*n_ptr).image_type[0:n_images-1],"-On" ) eq -1), count)	; keep all ski jumps if any mode with lights on (Lin-On or PCal-On
	if(count ne 0) then begin
		(*g_ptr).image_group_list[1,ind] = -1
	endif
	;
	;	turn on LED stack
	;
	sense = 1
	P2_LED_sensitize, Event, 3, sense
	;
	;	and set up LED constants
	;
	n_LED = 25
	;
	;	clear the LED string to orange to signify the start
	;
	colors = strarr(n_LED)
	colors[*] = "orange"
	LED_wid = (*s_ptr).P2_LED_wid[3]
	WCT_LED_stack, LED_wid, colors
	;
	;	don't make more than maximum number of groups
	;
	;	start looking at the first image
	;
	image_no = 0
	n_groups = 0
	WHILE (image_no lt n_images) do begin
		;
		current_LED = image_no MOD n_LED
		if(current_LED eq 0) then colors[*] = "orange"
		;
		colors[current_LED] = "yellow"
		WCT_LED_stack, LED_wid, colors
		;
		;	are there any more images without group assignments?
		;
		ind = WHERE( (*g_ptr).image_group_list[1,image_no:n_images-1] eq 0,count)
		if(count eq 0) then goto, loop_end				; no more to be found
		;
		;	found one needing a group, go group it
		;
		(*g_ptr).start_image = (*g_ptr).image_group_list[0,ind[0]+image_no]	; starting image
		(*g_ptr).image_group_list[1,ind[0]+image_no] = n_groups+1			; set it to next group
		;
		;	load some of the night summary structure before building the group
		;
		(*n_ptr).groups[n_groups].group_id = n_groups+1
		(*n_ptr).groups[n_groups].group_start = (*g_ptr).start_image
		(*g_ptr).group_no = n_groups+1
		(*g_ptr).image_index = ind[0]+image_no
		;
		P2_Build_A_Group, Event, g_ptr		; builds one group
		;
		n_groups++
		if(n_groups gt max_groups) then begin
			MSP_BDP_print_text, Event, "Too many groups ("+STRING(format='(i)',n_groups)+") requested. Max = "+STRING(format='(i)',max_groups)
			goto, loop_end
		endif
		colors[current_LED] = "green"
		WCT_LED_stack, LED_wid, colors
		;
		;	bump the search counter
		;
		image_no++
	ENDWHILE
	;
	;	all groups found, save and exit
	;
	loop_end:
	colors[current_LED] = "green"
	WCT_LED_stack, LED_wid, colors
	;
	MSP_BDP_print_text, Event, "Found a total of "+STRING(format='(i)',n_groups)+" groups"
	;
	;	load
	;
	(*n_ptr).num_groups = n_groups
	;
	root_raw = (*s_ptr).root_raw
	night_desig = (*n_ptr).night_desig
	night_dir = STRING(format='(i8.8)',night_desig)
	;
	;	save the night summary to disk as an IDL sav file
	;
	MSP_BDP_Create_Night_File_Path, Event, night_desig, night_file_path
    ;
	MSP_BDP_Save_Night_File, Event, night_file_path
	;
	MSP_BDP_print_text, Event, "Saved Night File = "+night_file_path
	;
	;	after groups built, turn on group edit, print, save
	;
	sense = 1
	P2_button_sensitize, Event, 6, sense
	P2_button_sensitize, Event, 7, sense
	;P2_button_sensitize, Event, 9, sense
	;
	;	release g_ptr
	;
	PTR_FREE, g_ptr
end
;
;-----------------------------------------------------------------
pro P2_Edit_Image_Table, Event
	;
	;	puts up the Image table for a night, allowing editing
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	;
	n_ptr = PTR_struct.PTR_night
	;
	;	build the table structure
	;
	col_headers = ["   Object Name    ", "ImagType", "FilterTyp", " Exp. T",$
					" HWP Ang", " SkJp", " Frame ", "Cam.", " Pind", " CoAdd", "--- Comments ---"]
	;
	n_images = (*n_ptr).num_images
	format = strarr(11,n_images)
	format[0:2,*] = '(a)'
	format[4,*] = '(3x,f5.1)'
	format[5,*] = '(2x,i4.2)'
	format[6,*] = '(a)'
	format[7,*] = '(1x,a)'
	format[8,*] = '(2x,i1.1)'		; the image_path_index number to the raw data (0=orig; 1=koko; 2=jump)
	format[9,*] = '(1x,i3)'
	format[10,*] = '(1x,a)'
	;
	color_array = strarr(11,n_images)
	;
	row_headers = strarr(n_images)
	data_line = {object: '', type: '', filter: '',$
				 expt: 0.0, HWP: 0.0, SJ: 0, frame: '', cam: '', Pind: 0, coadds: 1, comment: ''}
	data_array = REPLICATE(data_line, n_images)			; array of structures
	;
	for i_image = 0, n_images-1 do begin
			;
			;	show positive image number if the image has not been modified from raw,
			;	else show parens around the image number to signify it has
			;
			h_text = "I_"
			i_text = STRTRIM(STRING(format='(i5.3)',(*n_ptr).image_list[i_image]),2)
			;
			if( (*n_ptr).image_root_index[i_image] le 0) then begin
				row_headers[i_image] = h_text+i_text
			endif else begin
				row_headers[i_image] = '('+h_text+i_text+')'
			endelse
			;
			data_array[i_image].object    = (*n_ptr).image_object[i_image]
			data_array[i_image].type    = (*n_ptr).image_type[i_image]
			data_array[i_image].filter    = (*n_ptr).image_filter[i_image]
			expt    = (*n_ptr).image_exptime[i_image]
			data_array[i_image].expt = expt
			if(expt eq 0.0) then begin
				format[3,i_image] = '(f9.1)'
			endif else begin
				if(expt lt 1.0) then begin
					format[3,i_image] = '(f9.3)'
				endif else begin
					if(expt lt 10.0) then begin
						format[3,i_image] = '(f9.3)'
					endif else begin
						if(expt lt 100.0) then begin
							format[3,i_image] = '(f9.2)'
						endif else begin
							if(expt lt 1000.0) then begin
								format[3,i_image] = '(f9.1)'
							endif else begin
								format[3,i_image] = '(f9.0)'
							endelse
						endelse
					endelse
				endelse
			endelse
			data_array[i_image].HWP    = (*n_ptr).image_HWP_angle[i_image]
			data_array[i_image].Pind    = (*n_ptr).image_root_index[i_image]
			data_array[i_image].SJ    = (*n_ptr).image_ski_jump[i_image]
			data_array[i_image].frame = (*n_ptr).image_frame[i_image]
			data_array[i_image].cam    = (*n_ptr).image_camera[i_image]
			data_array[i_image].coadds = (*n_ptr).image_coadds[i_image]
			data_array[i_image].comment    = (*n_ptr).image_comment[i_image]
			;
			color_array[*,i_image] = "white"
			;
			case data_array[i_image].type of
				"Skip": color = 'red'
				"**BAD**":	color = "red"
				"Bias":	color = "skyblue"
				"Dark": color = "grey68"
				"Pol-Img": color = "lawngreen"
				"Pol-Spec": color = "pink"
				"Spec": color = "plum"
				"Image": color = "yellow"
				"S-Argon": color = "slateblue"
				"Lin-On": color = "khaki light"
				"Lin-Off": color = "khaki dark"
				"I-Flat-On": color = "goldenrod light"
				"I-Flat-Off": color = "goldenrod dark"
				"S-Flat-On": color = "rosybrown light"
				"S-Flat-Off": color = "rosybrown dark"
				"P-Flat-On": color = "palegreen light"
				"P-Flat-Off": color = "palegreen dark"
				"R-Flat-Off": color = "steelblue dark"
				"R-Flat-On": color = "steelblue light"
				"PCal-On" : color = "palegreen light"
				"PCal-Off" : color = "palegreen dark"
				else: color = "white"
			endcase
			;
			color_array[*,i_image] = color
			;
			;	next, if the ski-jump code is NOT 11, then color the ski jump field
			;	differently
			;
			if(data_array[i_image].SJ ne 11) then begin
				case data_array[i_image].SJ of
					10:	color_array[5,i_image] = "white"
					01: color_array[5,i_image] = "white"
					00: color_array[5,i_image] = "white"
					else: color_array[5,i_image] = "red"
				endcase
			endif
	endfor
	;
	r_string = STRING(format='("Summary for Night ",I8.8)', (*n_ptr).night_desig)
	new_struct = Dialog_Big_Table(Title="Image Summary Table"+$
		"    to ignore an image, put 'Skip' in its ImgType entry",Label=r_string, $
					Group_Leader=Event.top, Col_Headers = col_headers, $
					Format=format, Row_headers = row_headers,$
					Data_array = data_array, Font='Helvetica*16', $
					color_array=color_array)
	;
	;	load new table data back into structure
	;
	nc = N_TAGS(new_struct)
	nr = N_ELEMENTS(new_struct)
	;
	;	note - deletion of images not allowed
	;
	for ir = 0, nr-1 do begin
		(*n_ptr).image_object[ir] = 	new_struct[ir].object
		if(new_struct[ir].type eq "**BAD**" or STRUPCASE(new_struct[ir].type) eq "SKIP") then new_struct[ir].type = "Skip"
		(*n_ptr).image_type[ir] = 		new_struct[ir].type
		(*n_ptr).image_filter[ir] = 	new_struct[ir].filter
		(*n_ptr).image_exptime[ir] = 	new_struct[ir].expt
		(*n_ptr).image_HWP_angle[ir] = 	new_struct[ir].HWP
		(*n_ptr).image_ski_jump[ir] = 	new_struct[ir].SJ
		(*n_ptr).image_frame[ir] = 		new_struct[ir].frame
		(*n_ptr).image_camera[ir] = 	new_struct[ir].cam
		(*n_ptr).image_root_index[ir] = new_struct[ir].Pind
		(*n_ptr).image_coadds[ir] = 	new_struct[ir].coadds
		(*n_ptr).image_comment[ir] = 	new_struct[ir].comment
	endfor
	;
end
;
;-----------------------------------------------------------------
pro P2_Edit_Group_Table, Event
	;
	;	puts up the Group table for a night, allowing editing
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	;
	n_ptr = PTR_struct.PTR_night
	;
	;	build the table structure
	;
	col_headers = ["Start"," Stop","N_Img", "   Object Name    ", "ImagType", "FilterTyp", " Exp. T",$
					" Frame ", "Cam.", " RdMd", " CoAdd"]
	;
	n_groups = (*n_ptr).num_groups
	;
	;	if no groups yet, don't continue
	;
	if(n_groups le 0) then begin
		MSP_BDP_print_text, Event, "No groups identified yet -- use Build Groups first"
		goto, P2EGT_end
	endif
	;
	format = strarr(11,n_groups)
	format[0:1,*] = '(i4.3)'
	format[2,*] = '(i4)'
	format[3:5,*] = '(a)'
	format[6,*] = '(3x,f5.1)'
	format[7:8,*] = '(a)'
	format[9,*] = '(2x,i1.1)'
	format[10,*] = '(1x,i3)'
	;
	color_array = strarr(11,n_groups)
	;
	row_headers = strarr(n_groups)
	data_line = {start: 0, stop: 0, n_images: 0, object: '', type: '', filter: '',$
				 expt: 0.0, frame: '', cam: '', RM: 0, coadds: 1}
	data_array = REPLICATE(data_line, n_groups)			; array of structures
	;
	for i_group = 0, n_groups-1 do begin
			;
			;	group structure for this group
			;
			this_group = (*n_ptr).groups[i_group]
			;
			i_text = STRTRIM(STRING(format='(i4.1)',i_group),2)
			row_headers[i_group] = 'Gr_'+i_text
			;
			data_array[i_group].start = this_group.group_start
			data_array[i_group].stop = this_group.group_end
			data_array[i_group].n_images = this_group.group_images
			data_array[i_group].object    = this_group.group_object
			data_array[i_group].type    = this_group.group_type
			data_array[i_group].filter    = this_group.group_filter
			expt    = this_group.group_exptime
			data_array[i_group].expt = expt
			if(expt eq 0.0) then begin
				format[6,i_group] = '(f9.1)'
			endif else begin
				if(expt lt 1.0) then begin
					format[6,i_group] = '(f9.3)'
				endif else begin
					if(expt lt 10.0) then begin
						format[6,i_group] = '(f9.3)'
					endif else begin
						if(expt lt 100.0) then begin
							format[6,i_group] = '(f9.2)'
						endif else begin
							if(expt lt 1000.0) then begin
								format[6,i_group] = '(f9.1)'
							endif else begin
								format[6,i_group] = '(f9.0)'
							endelse
						endelse
					endelse
				endelse
			endelse
			data_array[i_group].RM    = this_group.group_readout_mode
			data_array[i_group].frame = this_group.group_frame
			data_array[i_group].cam    = this_group.group_camera
			data_array[i_group].coadds = this_group.group_coadds
			;
			color_array[*,i_group] = "white"
			;
			case data_array[i_group].type of
				"Skip": color = "red"
				"**BAD**":	color = "red"
				"Bias":	color = "skyblue"
				"Dark": color = "grey68"
				"Pol-Img": color = "lawngreen"
				"Pol-Spec": color = "pink"
				"Spec": color = "plum"
				"Image": color = "yellow"
				"S-Argon": color = "slateblue"
				"Lin-On": color = "khaki light"
				"Lin-Off": color = "khaki dark"
				"I-Flat-On": color = "goldenrod light"
				"I-Flat-Off": color = "goldenrod dark"
				"S-Flat-On": color = "rosybrown light"
				"S-Flat-Off": color = "rosybrown dark"
				"P-Flat-On": color = "palegreen light"
				"P-Flat-Off": color = "palegreen dark"
				"R-Flat-Off": color = "steelblue dark"
				"R-Flat-On": color = "steelblue light"
				"PCal-On": color = "palegreen light"
				"PCal-Off": color = "palegreen dark"
				else: color = "white"
			endcase
			;
			color_array[*,i_group] = color
			;
	endfor
	;
	r_string = STRING(format='("Groups for Night ",I8.8)', (*n_ptr).night_desig)
	new_struct = Dialog_Big_Table(Title="Group Summary Table"+$
		"    to ignore a group, put 'Skip' in its ImagType entry",Label=r_string, $
					Group_Leader=Event.top, Col_Headers = col_headers, $
					Format=format, Row_headers = row_headers,$
					Data_array = data_array, Font='Helvetica*16', $
					color_array=color_array)
	;
	;	load new table data back into structure
	;
	nc = N_TAGS(new_struct)
	nr = N_ELEMENTS(new_struct)
	;
	;	note - deletion of images not allowed
	;
	for ir = 0, nr-1 do begin
		(*n_ptr).groups[ir].group_start = new_struct[ir].start
		(*n_ptr).groups[ir].group_end = new_struct[ir].stop
		(*n_ptr).groups[ir].group_images = new_struct[ir].n_images
		(*n_ptr).groups[ir].group_object = new_struct[ir].object
		if(STRUPCASE(new_struct[ir].type) eq "**BAD**" or STRUPCASE(new_struct[ir].type) eq "SKIP") then new_struct[ir].type = "Skip"
		(*n_ptr).groups[ir].group_type = new_struct[ir].type
		(*n_ptr).groups[ir].group_filter = new_struct[ir].filter
		(*n_ptr).groups[ir].group_exptime = new_struct[ir].expt
		(*n_ptr).groups[ir].group_frame = new_struct[ir].frame
		(*n_ptr).groups[ir].group_camera = new_struct[ir].cam
		(*n_ptr).groups[ir].group_readout_mode = new_struct[ir].RM
		(*n_ptr).groups[ir].group_coadds = new_struct[ir].coadds
	endfor
	;
	P2EGT_end:
end
;
;-----------------------------------------------------------------
pro P2_Save_Image_Group_Tables, Event
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	n_ptr = PTR_struct.PTR_night
	s_ptr = PTR_struct.PTR_summary
	;
	night_desig = (*n_ptr).night_desig
	;
	;	save the night summary to disk as an IDL sav file
	;
	MSP_BDP_Create_Night_File_Path, Event, night_desig, night_file_path
    ;
	MSP_BDP_Save_Night_File, Event, night_file_path
	;
	MSP_BDP_print_text, Event, "Saved Night File = "+night_file_path
	;
	;	also update the run summary and save it
	;
	ind = WHERE( (*s_ptr).night_date[*] eq night_desig, count)
	if(count eq 0) then begin
		MSP_BDP_print_text, Event, "ERROR - No night with designation "+STRING(format='(I8.8)',$
		      night_desig)+" in run summary"
    endif else begin
    	num_images = (*n_ptr).num_images
    	(*s_ptr).night_images[ind] = num_images
    	;
    	;	if grouping done, set step to 2 with new comment
    	;
    	if( (*n_ptr).num_groups eq 0) then begin
    		(*s_ptr).night_step[ind] = 2
    		(*s_ptr).night_comment[ind] = "Directory Built"
    		(*s_ptr).night_who[ind] = (*s_ptr).who
    	endif else begin
	    	(*s_ptr).night_step[ind] = 2
	    	(*s_ptr).night_comment[ind] = "Groups Built"
	    	(*s_ptr).night_who[ind] = (*s_ptr).who
	    endelse
    	;
    	P1_Write_Summary_File, Event
    	;
    endelse
end
;
;-----------------------------------------------------------------
pro P2_Print_Group_Table, Event

end
;
;-----------------------------------------------------------------
pro P2_Print_Image_Table, Event

end
