;
;	Part 5 Event Handler Routines - Bad Pixel Mask Building
;
;-----------------------------------------------------------------
;
pro P5_Select_Night, Event
	;
	MSP_BDP_print_text, Event, "Night Selection Requested"
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE = PTR_struct
	n_ptr = PTR_struct.PTR_night
	s_ptr = PTR_struct.PTR_summary
	b_ptr = PTR_struct.PTR_BPM
	;
	wid = (*s_ptr).P5_droplist_night_wid[0]
	;
	night_index = Event.index
	;
	;	index is not enough, as we might not have done all the part 2
	;	stuff.... So, need to get the night designation from the list
	;
	WIDGET_CONTROL, wid, GET_VALUE = vector_night_desig
	selected_night_desig = vector_night_desig[night_index]
	;
	night_desig = selected_night_desig
	night_text = STRING(format='(I8.8)',night_desig)
	;
	;	reset buttons, and LEDs
	;
	for iw = 0, N_ELEMENTS( (*s_ptr).P5_button_wid)-1 do begin
		if(iw le 0) then sense = 1 else sense = 0
		P5_button_sensitize, Event, iw, sense
		;if(iw le 1) then P5_base_sensitize, Event, iw, 0
		if(iw eq 0) then P5_LED_sensitize, Event, iw, 0
	endfor
	;
	;	read in that night's save file
	;
	MSP_BDP_print_text, Event, "Opening Night Summary for night = "+night_text
	;
	MSP_BDP_Create_Night_File_Path, Event, night_desig, night_file_path
	MSP_BDP_Restore_Night_File, Event, night_file_path, description, ierr
	;
	if(ierr ne 0) then begin
		MSP_BDP_print_text, Event, "Could not restore night "+night_text+" - skipping"
		goto, P5SN_end
	endif
	;
	;	must redo pointers
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE = PTR_struct
	s_ptr = PTR_struct.PTR_summary
	n_ptr = PTR_struct.PTR_night
	raw_root = (*s_ptr).root_raw
	;
	;	capture number of groups
	;
	ngroups = (*n_ptr).num_groups
	ngroups_text = STRING(format='(I)',ngroups)
	MSP_BDP_print_text, Event, "Restored "+night_text+" with "+ngroups_text+" groups"
	;
	;	turn on first button
	;
	P5_button_sensitize, Event, 0, 1
	;
	;	and clear plot
	;
	WSET, (*s_ptr).P5_draw_window_id
	ERASE
	;
	;	set radio buttons to defaults
	;
	(*b_ptr).bpm_radio_flags[*] = 0
	(*b_ptr).bpm_radio_flags[0] = 1
	for ib = 2,4 do WIDGET_CONTROL, (*s_ptr).P5_button_wid[ib], SET_BUTTON=(*b_ptr).bpm_radio_flags[ib-2]
	(*b_ptr).bpm_histo_flags[*] = 0
	(*b_ptr).bpm_histo_flags[0] = 1
	for ib = 8,9 do WIDGET_CONTROL, (*s_ptr).P5_button_wid[ib], SET_BUTTON=(*b_ptr).bpm_histo_flags[ib-8]
	;
	WIDGET_CONTROL, (*s_ptr).P5_droplist_night_wid[1], SENSITIVE=0		; TBD off for now
	;
	P5SN_end:
end
;
;------------------------------------------------------
pro P5_Show_Table, Event
	;
	;	show the table of BPM images to be built from BIAS groups
	;
	MSP_BDP_print_text, Event, "Show/Edit Groups for BPM Evaluation requested"
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE = PTR_struct
	s_ptr = PTR_struct.PTR_summary
	n_ptr = PTR_struct.PTR_night
	r_ptr = PTR_struct.PTR_RAW1
	b_ptr = PTR_struct.PTR_BPM
	;
	night_desig = (*n_ptr).night_desig
	night_desig_text = STRING(format='(I8.8)',night_desig)
	;
	(*b_ptr).position = [35,33,430,292]		; plot position
	;
	root_raw = (*s_ptr).root_raw
	;
	n_images = (*n_ptr).num_images
	file_list = (*n_ptr).image_list[0:n_images-1]
	image_type = (*n_ptr).image_type[0:n_images-1]
	image_frame = (*n_ptr).image_frame[0:n_images-1]
	;
	input_pathname_list = strarr(n_images)
	;
	;	get the group info
	;
	n_groups = (*n_ptr).num_groups
	n_bpm = 0L
	;
	(*b_ptr).bpm_mode = 0		; starting to build masks
	;
	for ig = 0, n_groups-1 do begin
		;
		;	is this group a BIAS group?
		;
		this_group_type = (*n_ptr).groups[ig].group_type
		this_group_exp = (*n_ptr).groups[ig].group_exptime
		;
		;	add test for subframe mode - reject for now if so  (DPC 2008/3/4)
		;
		this_group_frame = (*n_ptr).groups[ig].group_frame
		;
		tgt_UC = STRUPCASE(this_group_type)
		test_1 = (tgt_UC  eq 'BIAS')			; save bias groups, or
		test_2 = (tgt_UC eq 'DARK')				; darks with 0 sec times
		test_3 = this_group_exp eq 0.0
		test_23 = test_2 && test_3
		;
		test_4 = (STRUPCASE(this_group_frame) ne 'FULL')
		;
		if(test_4) then goto, group_loop_end			; if subframed, don't include
		;
		if(NOT(test_1) and NOT(test_23)) then goto, group_loop_end
		;
		;	this group is a bias (or 0s Dark) group, add its info to the BPM structure
		;
		group_id = (*n_ptr).groups[ig].group_id
		group_images = (*n_ptr).groups[ig].group_images
		image_list = (*n_ptr).groups[ig].group_list[0:group_images-1]
		;
		;	UT
		;
		image_no = image_list[0]
		ind = WHERE( (*n_ptr).image_list[0:n_images-1] eq image_no, count)
		if(count ne 1) then begin
			MSP_BDP_print_text, Event, "ERROR - no match of image no in P5 UT load. image_no = "+STRING(format='(i)',image_no)
			goto, group_loop_end
		endif
		;
		(*b_ptr).BPM[n_bpm].ut = (*n_ptr).header_list[ind[0]].ut
		;
		(*b_ptr).bpm_n_BPM = n_bpm+1
		(*b_ptr).this_BPM_no = n_bpm
		(*b_ptr).BPM[n_bpm].serial_no = n_bpm
		(*b_ptr).BPM[n_bpm].image_name = 'BPM_'+night_desig_text+"_"+STRTRIM(STRING(format='(i)',n_bpm),2)+'.fits'
		(*b_ptr).BPM[n_bpm].night_desig = night_desig
		(*b_ptr).BPM[n_bpm].group_id = group_id
		(*b_ptr).BPM[n_bpm].n_images = group_images
		;
		;	set high/low cuts to defaults
		;
		(*b_ptr).BPM[n_bpm].low_cut = (*b_ptr).bpm_default_low_cut
		(*b_ptr).BPM[n_bpm].high_cut = (*b_ptr).bpm_default_high_cut
		;
		;	image pathnames, resolved as to raw directory
		;
		for ii = 0, group_images-1 do begin
			;
			ind = WHERE( (*n_ptr).image_list[0:n_images-1] eq image_list[ii],count)
			if(count ne 1) then begin
				MSP_BDP_print_text, Event, "ERROR - no match of image no in P5 pathname load. image_no = "+STRING(format='(i)',image_list[ii])
				goto, group_loop_end
			endif
			;
			index = (*n_ptr).image_root_index[ind[0]]
			directory = (*n_ptr).paths_cds_root[index]
			;
			if(index eq 0) then begin
				base_dir = (*s_ptr).root_raw
			endif else begin
				base_dir = (*s_ptr).root_reduced
			endelse
			;
			directory = base_dir + directory
			;
			image_no_text = STRTRIM(STRING(format='(i5.3)',image_list[ii]),2)
			path = fix_path( FILEPATH(night_desig_text+"."+image_no_text+".fits", ROOT_DIR=directory) )
			;
			(*b_ptr).BPM[n_bpm].images_included[ii] = path
		endfor
		;
		;	increment bpm counter
		;
		n_bpm++
		;
		MSP_BDP_print_text, Event, "For BPM "+STRING(format='(i)',n_bpm)+" found "+STRING(format='(i)',group_images)+" images"
		;
		group_loop_end:
	endfor
	;
	(*b_ptr).bpm_n_BPM = n_bpm
	;
	;	if there are no bpms to build, then write summary and exit
	;
	if(n_bpm eq 0) then begin
		;
		;print, "position array = ",(*b_ptr).position
		;
		MSP_BDP_print_text, Event, "No Bias groups found to build BPMs from."
		num_nights = (*s_ptr).num_nights
		ind = WHERE(night_desig eq (*s_ptr).night_date[0:num_nights-1], count)
		if(count ne 0) then night_index = ind[0] else begin
			MSP_BDP_print_text, Event, "Error - No matching night in P5..."
			goto, P5_ST_end
		endelse
		;
		(*s_ptr).night_step[night_index] = 5
		text = "No BPMs Made"
		(*s_ptr).night_comment[night_index] = text
		;
		P1_Write_Summary_File, Event
		;
		P5_Draw_Done, Event, TEXT=text
		;
		goto, P5_ST_end
	endif
	;
	(*b_ptr).bpm_directory = '5_Bad_Pixel_Masks'
	bpm_dir_path = fix_path( (*s_ptr).root_reduced + (*b_ptr).bpm_directory )
	;
	;	see if this directory exists
	;
	test_dir = FILE_INFO( bpm_dir_path )
	if( NOT(test_dir.exists) or NOT(test_dir.directory) ) then begin
		MSP_BDP_print_text, Event, "Creating new BPM directory"
		FILE_MKDIR, bpm_dir_path
	endif
	;------------------------------------------------------------------------------------
	;
	;	build the table structure
	;
	col_headers = ["Group", "____UT____", "N_Images", "__Status__", $
					" Low_Cut", " High_Cut", " N_Bad "]
	;
	n_lines = (*b_ptr).bpm_n_BPM
	format = strarr(7,n_lines)
	format[0,*] = '(a)'
	format[1,*] = '(a)'				; UT converted to string
	format[2,*] = '(i)'
	format[3,*] = '(a)'
	format[4,*] = '(f6.1)'
	format[5,*] = '(f6.1)'
	format[6,*] = '(i)'
	;
	color_array = strarr(7,n_lines)
	;
	row_headers = strarr(n_lines)
	data_line = {group_id: '', UT: '', n_images: 0,$
				 status: '', low_cut: 0.0, high_cut: 0, n_bad: 0L}
	data_array = REPLICATE(data_line, n_lines)			; array of structures
	;
	for i = 0, n_lines-1 do begin
			;
			row_headers[i] = 'BPM_'+STRTRIM(STRING(format='(i)',i),2)
			;
			g_text = STRTRIM(STRING(format='(i)',(*b_ptr).BPM[i].group_id),2)
			data_array[i].group_id    = 'Gr_'+g_text
			;
			;	convert UT to string
			;
			ut = (*b_ptr).BPM[i].ut
			uth = fix(ut)
			utm = fix( 60.0*(ut - uth))
			uts = ut*3600.0d0 - double(uth)*3600.0d0 - double(utm)*60.0d0
			utsx = fix(uts/10.0)
			uts = uts - 10.0*utsx
			ut_text = STRING(format='(i2.2,":",i2.2,":",i1.1,f3.1)',uth,utm,utsx,uts)
			;
			data_array[i].ut    		= ut_text
			data_array[i].n_images    	= (*b_ptr).BPM[i].n_images
			if( (*b_ptr).bpm_mode eq 0) then begin
				data_array[i].status 		= 'Proposed'
				data_array[i].n_bad 		= 0
			endif else begin
				data_array[i].status		= 'Existing'
				data_array[i].n_bad			= (*b_ptr).BPM[i].n_bad_pixels
			endelse
			;
			data_array[i].low_cut    	= (*b_ptr).BPM[i].low_cut
			data_array[i].high_cut 		= (*b_ptr).BPM[i].high_cut
			;
			color_array[*,i] = "white"
			;
			case data_array[i].status of
				"Proposed":	color = "yellow"
				"Existing":	color = "lawngreen"
				else: color = "white"
			endcase
			;
			color_array[*,i] = color
			;
	endfor
	;
	r_string = STRING(format='("BPM List for Night ",I8.8)', (*n_ptr).night_desig)
    new_struct = Dialog_Big_Table(Title="Bad Pixel Mask Summary Table",Label=r_string, $
					Group_Leader=Event.top, Col_Headers = col_headers, $
					Format=format, Row_headers = row_headers,$
					Data_array = data_array, Font='Helvetica*16', $
					color_array=color_array)
	;
	;	load new table data back into structure
	;
	nc = N_TAGS(new_struct)
	nr = N_ELEMENTS(new_struct)
	;
	;	note - deletion of groups via setting type to skip
	;
;	for ir = 0, nr-1 do begin
;		(*n_ptr).image_object[ir] = 	new_struct[ir].object
;		if( STRUPCASE(new_struct[ir].type) eq 'SKIP') then new_struct[ir].type = 'Skip'
;		(*n_ptr).image_type[ir] = 		new_struct[ir].type
;		(*n_ptr).image_filter[ir] = 	new_struct[ir].filter
;		(*n_ptr).image_exptime[ir] = 	new_struct[ir].expt
;		(*n_ptr).image_HWP_angle[ir] = 	new_struct[ir].HWP
;		(*n_ptr).image_ski_jump[ir] = 	new_struct[ir].SJ
;		(*n_ptr).image_frame[ir] = 		new_struct[ir].frame
;		(*n_ptr).image_camera[ir] = 	new_struct[ir].cam
;		(*n_ptr).image_root_index[ir] = new_struct[ir].Pind
;		(*n_ptr).image_comment[ir] = 	new_struct[ir].comment
;	endfor
	;
	;	all the BPM groups built, populate, then show, table
	;
	;	at the end of the show/edit cycle, build the list of pathnames to
	;	the CDS images, resolving all redirect indices
	;
	;---------------------------------
	;
	;	turn on base and radio buttons
	;
	WIDGET_CONTROL, (*s_ptr).P5_base_wid[0], SENSITIVE=1
	WIDGET_CONTROL, (*s_ptr).P5_base_wid[3], SENSITIVE=1
	for ib = 2, 4 do P5_button_sensitize, Event, ib, 1
	for ib = 8, 9 do P5_button_sensitize, Event, ib, 1
	for ib = 10, 11 do P5_button_sensitize, Event, ib, 1
	;
	;	set radio buttons to defaults
	;
	(*b_ptr).bpm_radio_flags[*] = 0
	(*b_ptr).bpm_radio_flags[0] = 1
	for ib = 2,4 do WIDGET_CONTROL, (*s_ptr).P5_button_wid[ib], SET_BUTTON=(*b_ptr).bpm_radio_flags[ib-2]
	(*b_ptr).bpm_histo_flags[*] = 0
	(*b_ptr).bpm_histo_flags[0] = 1
	for ib = 8,9 do WIDGET_CONTROL, (*s_ptr).P5_button_wid[ib], SET_BUTTON=(*b_ptr).bpm_histo_flags[ib-8]
	;
	for ib = 10,11 do WIDGET_CONTROL, (*s_ptr).P5_button_wid[ib], SET_BUTTON=abs((11-ib) - (*b_ptr).bpm_multi_mode)
	;
	;	turn on button to enable processing start
	;
	P5_button_sensitize, Event, 1, 1
	;
	P5_ST_end:
end
;-----------------------------------------------------
pro P5_Radio_Button_2, Event, ibutton
	;;
	;	select whether to compute and use multiple BPMs for a night
	;
	;	if ibutton is 0 - set to single mode (use first BPM only)
	;
	;	if ibutton is 1 - set to multiple mode
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	s_ptr = PTR_struct.PTR_summary
	b_ptr = PTR_struct.PTR_BPM
	;
	if(ibutton ge 0 and ibutton lt 2) then begin
		;
		;	set ibutton and clear others
		;
		(*b_ptr).bpm_radio_flags[3:4] = 0
		(*b_ptr).bpm_radio_flags[ibutton+3] = 1
		;
	endif
	;
	;	show buttons
	;
	for ib = 10, 11 do begin
		WIDGET_CONTROL, (*s_ptr).P5_button_wid[ib], SET_BUTTON=(*b_ptr).bpm_radio_flags[ib-7]
	endfor
	;
	;	now, update mode flag
	;
	(*b_ptr).bpm_multi_mode = (*b_ptr).bpm_radio_flags[4]
	;
	;	once radio buttons are displayed, can turn on process button
	;
	P5_button_sensitize, Event, 1, 1
end
;
;
;-----------------------------------------------------
pro P5_Radio_Button_1, Event, ibutton
	;;
	;	select frequency of histogram anaysis
	;
	;	if ibutton is 0, 1, or 2 - select the right radio button, set the
	;	right flag for histogram plotting, halting
	;
	;	if ibutton is missing or out of that range, read the flags and
	;	set the right buttons
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	s_ptr = PTR_struct.PTR_summary
	b_ptr = PTR_struct.PTR_BPM
	;
	if(ibutton ge 0 and ibutton le 2) then begin
		;
		;	set ibutton and clear others
		;
		(*b_ptr).bpm_radio_flags[*] = 0
		(*b_ptr).bpm_radio_flags[ibutton] = 1
		;
	endif
	;
	;	show buttons
	;
	for ib = 2, 4 do begin
		WIDGET_CONTROL, (*s_ptr).P5_button_wid[ib], SET_BUTTON=(*b_ptr).bpm_radio_flags[ib-2]
	endfor
	;
	;	now, if second or third button set, turn on high-low cut text
	;
	if( (*b_ptr).bpm_radio_flags[1] or (*b_ptr).bpm_radio_flags[2]) then begin
		;
		;	base, too
		;
		WIDGET_CONTROL, (*s_ptr).P5_base_wid[1], SENSITIVE=1
		for iw = 0, 1 do begin
			WIDGET_CONTROL, (*s_ptr).P5_text_wid[iw], SENSITIVE=1
		endfor
	endif else begin
		;
		;	otherwise, turn them off
		;
		WIDGET_CONTROL, (*s_ptr).P5_base_wid[1], SENSITIVE=0
		for iw = 0, 1 do begin
			WIDGET_CONTROL, (*s_ptr).P5_text_wid[iw], SENSITIVE=0
		endfor
	endelse
	;
	;	once radio buttons are displayed, can turn on process button
	;
	P5_button_sensitize, Event, 1, 1
end
;
;--------------------------------------------
pro P5_Radio_Button_0, Event, ibutton
	;
	;	select how to build histogram
	;
	;	if ibutton is 0 or 1 - select the right radio button, set the
	;	right flag for histogram plotting, halting
	;
	;	if ibutton is missing or out of that range, read the flags and
	;	set the right buttons
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	s_ptr = PTR_struct.PTR_summary
	b_ptr = PTR_struct.PTR_BPM
	;
	if(ibutton ge 0 and ibutton le 1) then begin
		;
		;	set ibutton and clear others
		;
		(*b_ptr).bpm_histo_flags[*] = 0
		(*b_ptr).bpm_histo_flags[ibutton] = 1
		;
	endif
	;
	;	show buttons
	;
	for ib = 8, 9 do begin
		WIDGET_CONTROL, (*s_ptr).P5_button_wid[ib], SET_BUTTON=(*b_ptr).bpm_histo_flags[ib-8]
	endfor
	;
	;	once radio buttons are displayed, can turn on process button
	;
	P5_button_sensitize, Event, 1, 1
end
;-------------------------------------------
pro P5_Build_Histogram, Event
	;
	;	Computes and plots histogram of pixel counts for first image in list
	;	pointed to by "this_BPM_no"
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	s_ptr = PTR_struct.PTR_summary
	n_ptr = PTR_struct.PTR_night
	b_ptr = PTR_struct.PTR_BPM
	;
	night_desig = (*n_ptr).night_desig
	night_desig_text = STRING(format='(I8.8)',night_desig)
	;
	device, decomposed=0
	;
	;	get the current BPM index number
	;
	this_BPM_no = (*b_ptr).this_BPM_no
	;
	;	build a YYYYMMDD_BPM# type name
	;
	BPM_name = night_desig_text + "_" + STRTRIM(STRING(format='(i)',this_BPM_no),2)
	;
	;	report to text window
	;
	WIDGET_CONTROL, (*s_ptr).P5_text_wid[2], SET_VALUE=BPM_name
	;
	this_LED = (*b_ptr).this_LED
	colors = (*s_ptr).P5_LED_colors
	;
	;	and input image list
	;
	n_this_bpm = (*b_ptr).BPM[this_BPM_no].n_images
	input_pathname_list = (*b_ptr).BPM[this_BPM_no].images_included[0:n_this_bpm-1]
	;
	high_cut = (*b_ptr).bpm_high_cut
	low_cut = (*b_ptr).bpm_low_cut
	;
	xh = high_cut
	xc = low_cut
	;
	;   TEST for high_cut > low_cut
	;
	if(xc gt xh) then begin
	    ;print, "ERROR - low cut value HIGHER than high cut value, swapping values and continuing..."
	    xcs = xc
	    xc = xh
	    xh = xcs
	endif
	;
	MSP_BDP_print_text, Event, "Reading image "+input_pathname_list[0]
	(*s_ptr).P5_LED_colors[this_LED] = 'yellow'
	WCT_LED_stack, (*s_ptr).P5_LED_wid[0], (*s_ptr).P5_LED_colors
	;
	image = long(readfits(input_pathname_list[0],header,/SILENT))
	image_size = size(image)
	;
	;   now, generate histogram of data values
	;
	ymin = -150.0
	ymax = 180.0
	nb = 512 < (ymax - ymin + 1)
	;
	;   invoke ski_jump correction (20050613)
	;
	(*s_ptr).P5_LED_colors[this_LED] = 'orange'
	WCT_LED_stack, (*s_ptr).P5_LED_wid[0], (*s_ptr).P5_LED_colors
	MSP_BDP_print_text, Event, " ... starting Ski Jump fitting ..."
	image = bdp_ski_jump_fit_sub(image)
	;
	col0 = 2
	col1 = 1020
	row0 = 2
	row1 = 1023
	;
	nvec = long(row1-row0+1) * long(col1-col0+1)
	;
	vec = REFORM(image[col0:col1,row0:row1],nvec)
	;
	;help, vec
	;
	h = dpc_histogram(vec, MAX=ymax, MIN=ymin, NBINS=nb)
	x = ymin + (ymax - ymin) / (nb -1.) * FIndGen(nb)
	;
	;	 count off the ends
	;
	ind = WHERE(vec lt ymin, count_l)
	(*b_ptr).bpm_histogram_n_low = count_l
	ind = WHERE(vec gt ymax, count_h)
	(*b_ptr).bpm_histogram_n_high = count_h
	nbelow = count_l + count_h
	;
	;	now count number between cuts and ends
	;
	ind = WHERE(vec ge ymin and vec le low_cut, count_0)
	ind = WHERE(vec le ymax and vec ge high_cut, count_1)
	;
	(*s_ptr).P5_LED_colors[this_LED] = 'blue'
	WCT_LED_stack, (*s_ptr).P5_LED_wid[0], (*s_ptr).P5_LED_colors
	;
	;print, "Number of pixels below YMIN or above YMAX = ",nbelow
	;
	;	write to N_bad text window
	;
	WIDGET_CONTROL, (*s_ptr).P5_text_wid[3], SET_VALUE=STRING(format='(i)',nbelow+count_0+count_1)
	;
	;   for all the rest of the files, do same reading, histogram accumulation, finally plotting
	;   result
	;
	nfiles = 1
	;
	;	if the "All" radio button is set, do this loop
	;
	if( NOT(*b_ptr).bpm_histo_flags[1] ) then goto, skip_rest
	;
	nfiles = N_ELEMENTS(input_pathname_list)
	;
	if (nfiles ne 0) then begin
	    for nf = 1, nfiles-1 do begin       ; read the rest of the image files
	       MSP_BDP_print_text, Event, "Reading image "+input_pathname_list[nf]
	       (*s_ptr).P5_LED_colors[this_LED] = 'yellow'
		   WCT_LED_stack, (*s_ptr).P5_LED_wid[0], (*s_ptr).P5_LED_colors
	       image_n = long(readfits(input_pathname_list[nf], header, /SILENT))
	       ;
	       ;    invoke ski_jump correction (20050613)
	       ;
	       (*s_ptr).P5_LED_colors[this_LED] = 'orange'
		   WCT_LED_stack, (*s_ptr).P5_LED_wid[0], (*s_ptr).P5_LED_colors
	       MSP_BDP_print_text, Event, " ... starting Ski Jump fitting ..."
	       image_n = bdp_ski_jump_fit_sub(image_n)
	       ;
	       vec = image_n[col0:col1,row0:row1]
	      ;
	       hnew = dpc_histogram(vec, MAX=ymax, MIN=ymin, NBINS=nb)
	       dummy = where(vec lt ymin or vec gt ymax,nbelow_i)
	       h = h + hnew
	       nbelow = nbelow + nbelow_i
	       ;
	       (*s_ptr).P5_LED_colors[this_LED] = 'blue'
		   WCT_LED_stack, (*s_ptr).P5_LED_wid[0], (*s_ptr).P5_LED_colors
		   ;
	    endfor
	endif
	;
	skip_rest:
	MSP_BDP_print_text, Event, "Read "+STRING(format='(i)',nfiles)+" Bias images"
	;
	;	save histogram results
	;
	(*b_ptr).bpm_histogram_x = x
	(*b_ptr).bpm_histogram_y = h
	;
	(*s_ptr).P5_LED_colors[this_LED] = 'violet'
	WCT_LED_stack, (*s_ptr).P5_LED_wid[0], (*s_ptr).P5_LED_colors
	;
	P5_Plot_Histogram, Event
	;
end
;
;-------------------------------------------------
;
pro P5_Plot_Histogram, Event
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	s_ptr = PTR_struct.PTR_summary
	n_ptr = PTR_struct.PTR_night
	b_ptr = PTR_struct.PTR_BPM
	r_ptr = PTR_struct.PTR_RAW1
	;
	;	plot into widget draw window
	;
	device, decomposed=0
	color_red = REFORM((*r_ptr).color_rgb[0,*])
	color_green = REFORM((*r_ptr).color_rgb[1,*])
	color_blue = REFORM((*r_ptr).color_rgb[2,*])
	;
	tvlct, color_red, color_green, color_blue, 0
	;
	window_id = (*s_ptr).P5_draw_window_id
	;
	WSET, window_id
	;
	x = (*b_ptr).bpm_histogram_x
	y = (*b_ptr).bpm_histogram_y
	;
	ymin = (*b_ptr).bpm_default_low_plot
	ymax = (*b_ptr).bpm_default_high_plot
	;
	plot, x, y, /YLOG,yrange=[(1 > min(y)),max(y)],xrange=[ymin,ymax],xstyle=1,psym=10,$
				color=1, background=0, thick=1, LINESTYLE=0, $
				Xtitle = "Pixel Value", TITLE="Histogram of Pixel Values", $
				POSITION=(*b_ptr).position,/DEVICE, xtickinterval=30.0, $
				xminor=6, ycharsize=1.5
	;
	;	show low, high cut values
	;
	low = (*b_ptr).bpm_low_cut
	high = (*b_ptr).bpm_high_cut
	;
	WIDGET_CONTROL, (*s_ptr).P5_text_wid[0], SET_VALUE=STRING(format='(f6.1)',low)
	WIDGET_CONTROL, (*s_ptr).P5_text_wid[1], SET_VALUE=STRING(format='(f6.1)',high)
	;
	;	scale
	;
	x0 = (*b_ptr).position[0]
	x1 = (*b_ptr).position[2]
	dx = abs(x0 - x1)
	scale = (ymax - ymin) / double(x1 - x0)
	;
	;print, "scale = ",scale," pixels per x value"
	;
	;xl = x0 + (ymin - low)*scale
	xl = low
	xd = [xl,xl]
    yd = [1.,6000.]
    ;
    PlotS, xd, yd, linestyle=2, thick=3, color=5
    ;
    ;xh = x0 + (ymin - high)*scale
    xh = high
    xd = [xh, xh]
    PlotS, xd, yd, linestyle=2, thick=3, color=2
    ;
    ;	if radio button not "never", turn on base 2 and buttons, else turn them off
    ;
    if( NOT(*b_ptr).bpm_radio_flags[0]) then begin
    	WIDGET_CONTROL, (*s_ptr).P5_base_wid[2], SENSITIVE=1
    	for ib = 5, 7 do P5_button_sensitize, Event, ib, 1
    endif else begin
    	WIDGET_CONTROL, (*s_ptr).P5_base_wid[2], SENSITIVE=0
    	for ib = 5, 7 do P5_button_sensitize, Event, ib, 0
    endelse
end
;
;-----------------------------------------------------
pro P5_Modify_Plot, Event, CH
	;
	;	process "L", "H", and "C" commands
	;
	;	save results into both current and "this" buffers
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	r_ptr = PTR_struct.PTR_RAW1
	s_ptr = PTR_struct.PTR_summary
	b_ptr = PTR_struct.PTR_BPM
	;
	this_BPM = (*b_ptr).this_BPM_no
	last_BPM = (*b_ptr).bpm_n_BPM-1
	;
	xmax0 = (*b_ptr).position[2]
	xmin0 = (*b_ptr).position[0]
	;
	xv0 = (*b_ptr).bpm_default_low_plot
	xv1 = (*b_ptr).bpm_default_high_plot
	;
	xx = (*b_ptr).xx
	yy = (*b_ptr).yy
	;
	x_data_scale = float(xv1 - xv0)
	x_device_scale = float(xmax0-xmin0)
	xx_data = round((x_data_scale / x_device_scale) * float(xx - xmin0))
	xx_data = xx_data + xv0
	;
	;	do something to the plot, based on the CH character
	;
	if(ch eq 'L') then begin     ; reset low cut value
	    ;
	    (*b_ptr).bpm_low_cut = xx_data
	    (*b_ptr).BPM[this_BPM].low_cut = xx_data
	    ;
	    ;	if "first" or "never" buttons set, fill all buffers
	    ;
	    if( NOT(*b_ptr).bpm_radio_flags[2] ) then begin
	    	if(last_BPM gt this_BPM) then begin
	    		for i_bpm = this_BPM+1, last_BPM do begin
	    			(*b_ptr).BPM[i_bpm].low_cut = xx_data
	    		endfor
	    	endif
	    endif
	    ;
	    goto, replot
	endif
	;
	if(ch eq 'H') then begin   ; High cut
	    ;
	    (*b_ptr).bpm_high_cut = xx_data
	    (*b_ptr).BPM[this_BPM].high_cut = xx_data
	    ;
	    if( NOT(*b_ptr).bpm_radio_flags[2] ) then begin
	    	if(last_BPM gt this_BPM) then begin
	    		for i_bpm = this_BPM+1, last_BPM do begin
	    			(*b_ptr).BPM[i_bpm].high_cut = xx_data
	    		endfor
	    	endif
	    endif
	    ;
	    goto, replot
	endif
	;
	if(ch eq 'C') then begin   ; continue function - action depends on nature
		;						of the radio buttons
		;	turn off this base
		;
		P5_base_sensitize, Event, 2, 0
		;
	    P5_BPM_Make_Histo_Plot_Loop, Event
	    ;
	    goto, P5MP_end
	endif
	;
	;	reissue plot command
	;
replot:
	;
	P5_Plot_Histogram, Event
	;
	P5MP_end:
end
;
;---------------------------------------------------
pro P5_Compute_BPM, Event
	;
	;	computes the BPM and stores it
	;
	;   processes numerous Mimir files to generate a bad pixel mask image
	;   for upper or lower array halves or the entire array
	;
	;   DPC  8/28/2004
	;        2004/10/27 - updated to be able to use any size images
	;                     will query user for sizes different than read in,
	;                     for example to just process first read, or UL UR
	;     	20050608 - modified to allow use of file of filenames
	;     	20050613 - modified to call ski_jump_fit_sub to remove ski_jump trend before analysis
	;     	20050902 - modified to include command line arguments to allow calling by batch.pro
	;     	20060626 - fixed bug preventing running with batch.pro
	;     	20060725 - trapped for reversed cold, hot cut values and excess bad pixels
	;		20071204	copied from make_bad_pix_mask.pro
	;
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	s_ptr = PTR_struct.PTR_summary
	b_ptr = PTR_struct.PTR_BPM
	n_ptr = PTR_struct.PTR_night
	;
	this_BPM = (*b_ptr).this_BPM_no
	this_LED = (*b_ptr).this_LED
	colors = (*s_ptr).P5_LED_colors
	;
	;	n_sigma is the deviation threshold (multiplies dispersion)
	;
	n_sigma = 3.0
	;
	;	announce which BPM is begin constructed
	;
	BPM_file = (*b_ptr).BPM[this_BPM].image_name
	;
	BPM_text = STRING(format='(I8.8)',(*n_ptr).night_desig) + '_' + $
				STRTRIM(STRING(format='(i)',this_BPM),2)
	WIDGET_CONTROL, (*s_ptr).P5_text_wid[2], SET_VALUE=BPM_text
	;
	;	get the current high, low cuts and BPM index pointer
	;
	high_cut = (*b_ptr).BPM[this_BPM].high_cut
	low_cut = (*b_ptr).BPM[this_BPM].low_cut
	;
	xh = high_cut
	xc = low_cut
	;
	;   TEST for high_cut > low_cut (KEJ test)
	;
	if(xc gt xh) then begin
	    ;print, "ERROR - low cut value HIGHER than high cut value, swapping values and continuing..."
	    xcs = xc
	    xc = xh
	    xh = xcs
	endif
	;
	;print, "in Compute BPM, high, low cuts = ",xh, xc
	;
	n_this_bpm = (*b_ptr).BPM[this_BPM].n_images
	input_pathname_list = (*b_ptr).BPM[this_BPM].images_included[0:n_this_bpm-1]
	;
	image = readfits(input_pathname_list[0],header,/SILENT)
	image_size = size(image)
	ncol = image_size[1]
	nrow = image_size[2]
	;
	;   create bad pixel mask, using these hot, cold values as limits
	;
	;   start with a clean mask, then using each input image, accumulate bad
	;   pixel counts. After that, save as bad only those pixels whose count
	;   is > 75% of the number of input files.
	;
	bad_count_mask = IntArr(ncol,nrow)
	bad_count_mask[*,*] = 0
	;
	ixc = long(xc)
	ixh = long(xh)
	bad_row_refresh = IntArr(ncol)
	;
	for ifiles = 0L, n_this_bpm-1L do begin
		(*s_ptr).P5_LED_colors[this_LED] = 'yellow'
		WCT_LED_stack, (*s_ptr).P5_LED_wid[0], (*s_ptr).P5_LED_colors
		;
		MSP_BDP_print_text, Event, "Reading image "+input_pathname_list[ifiles]
	    image = long(readfits(input_pathname_list[ifiles],header,/SILENT))
	    if(ifiles eq 0) then begin
	    	save_header = header
	    	;
	    	;	test, fix any potential header variable problems
	    	;
	    	Test_Fix_Bad_Filter_Names, Event, 'Dark', HEADER=save_header
	    endif
			;	old version deprecated 20131220 DPC
			;    ;
			;	    ;   invoke ski_jump_correction (20050613)
			;	    ;
			;		(*s_ptr).P5_LED_colors[this_LED] = 'orange'
			;		WCT_LED_stack, (*s_ptr).P5_LED_wid[0], (*s_ptr).P5_LED_colors
			;		MSP_BDP_print_text, Event, " ... starting Ski Jump fitting ..."
			;	    image = ski_jump_fit_sub(image)
			;	    ;
			;	    ;	vector version
			;	    ;
			;	    mask_low = FLOOR(image,/L64) > ixc		; trap to no lower than low cut
			;	    mask_low -= ixc						; and subtract, so low cuts are at 0
			;	    mask_low <= 1						; all others are at 1
			;	    mask_high = CEIL(image,/L64) < ixh
			;	    mask_high -= ixh					; 0 where cut
			;	    mask_high >= -1
			;	    mask_high += 1						; so low mask is "good" but high mask is "bad"
			;	    ;
			;	    bad_count_mask += (1-mask_low) + mask_high
			;	    ;
		;---------------------------------------------------------------
		;	new version 20131220 DPC
		;
		;	for each row
		;
		n_this_bad = 0L
		;
		for ir = 0, nrow-1 do begin
			;
			;	select the row's data
			;
			this_vec = REFORM(image[*,ir])
			;
			;	try mfm
			;
			zz = median_filtered_mean(this_vec)
			;
			;	test for zero dispersion
			;
			if(zz[1] lt 0.01) then begin
				;
				bad_count_mask[*,ir]++
				n_this_bad += ncol
				;
			endif else begin
				;
				;	not zero dispersion, find all deviants outside N-sigma
				;
				ind = WHERE(abs(this_vec - zz[0])/zz[1] gt n_sigma,nbad)
				;
	;			print, 'N_bad in row ',ir,' = ',nbad
				;
				if(nbad gt 0) then begin
					bad_count_mask[ind,ir]++
					n_this_bad += nbad
				endif
			endelse
		endfor
	;
;	print, 'Number of bad pixels in image ',FILE_BASENAME(files_in[ii]),' = ',n_this_bad
	;
	endfor
	;
	(*s_ptr).P5_LED_colors[this_LED] = 'blue'
	WCT_LED_stack, (*s_ptr).P5_LED_wid[0], (*s_ptr).P5_LED_colors
	;
	frac_test = ROUND(0.75*float(n_this_bpm))
	;
	;print, "frac test = ",frac_test
	;
	bad_mask = IntArr(ncol,nrow)
	bad_mask[*,*] = 0
	;
	bcount = 0L
	;
			; old, no need	;	vector version
			;	;
			;	mask_bad = bad_count_mask - frac_test
			;	mask_bad <= 0
			;	mask_bad >= -1							; really, all bad = 0, all good = -1
			;	bcount = nrow * ncol + LONG(TOTAL(mask_bad,/DOUBLE))
			;	;
			;	bad_mask = mask_bad
			;	bad_mask += 1
			;	;
			;	;
	ind = WHERE(bad_count_mask ge frac_test, bcount)
	bad_mask[ind] = 1
	;
	BPM_text = STRTRIM(STRING(format='(i)',bcount),2)
	WIDGET_CONTROL, (*s_ptr).P5_text_wid[3], SET_VALUE=BPM_text
	;
	;   test for really high bad pixel counts
	;
	if(bcount gt 10000) then MSP_BDP_print_text, Event,"WARNING - Too many bad pixels ("+$
			STRING(format='(i)',bcount)+') for '+BPM_file
	;
	;	build output BPM pathname
	;
	output_pathname = fix_path( FILEPATH(BPM_file, ROOT_DIR=(*s_ptr).root_reduced, SUBDIRECTORY=(*b_ptr).bpm_directory))
	;
	;	update header with info
	;
	FXADDPAR, save_header, "FILENAME", BPM_file, "Computed Bad Pix Mask"
	FXADDPAR, save_header, "HISTORY","  Created Bad Pixel Mask on "+SYSTIME()
	FXADDPAR, save_header, "HISTORY","    reduction performed by "+(*s_ptr).who
	FXADDPAR, save_header, "HISTORY", "            using the following images:"
	for ifiles = 0, n_this_bpm-1 do begin
		FXADDPAR, save_header, "HISTORY", "      "+FILE_BASENAME(input_pathname_list[ifiles])
	endfor
	FXADDPAR, save_header, "N_BADPIX", bcount, "Bad Pixel Count for this mask"
	FXADDPAR, save_header, "BPM_LCUT", (*b_ptr).bpm_low_cut,"Histogram Low Cut for BPM creation"
	FXADDPAR, save_header, "BPM_HCUT", (*b_ptr).bpm_high_cut,"Histogram High Cut for BPM creation"
	FXADDPAR, save_header, "BDP_NGHT", (*b_ptr).BPM[this_BPM].night_desig, "MSP_BDP Night Designation"
	FXADDPAR, save_header, "BDP_GRP", (*b_ptr).BPM[this_BPM].group_id, "MSP_BDP Group Number "
	;
	writefits, output_pathname, bad_mask, save_header
	;
	MSP_BDP_print_text, Event,"Write output image "+output_pathname
	(*s_ptr).P5_LED_colors[this_LED] = 'green'
	WCT_LED_stack, (*s_ptr).P5_LED_wid[0], (*s_ptr).P5_LED_colors
	;
end
;-------------
pro P5_Start_BPM_Creation, Event
	;
	;	start the process of making first image histograms,
	;	plotting, and evaluating what to do based on the radio
	;	buttons.
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	s_ptr = PTR_struct.PTR_summary
	n_ptr = PTR_struct.PTR_night
	b_ptr = PTR_struct.PTR_BPM
	;
	; turn off LHC base and radio button base
	;
	P5_base_sensitize, Event, 2, 0
	P5_base_sensitize, Event, 0, 0
	P5_base_sensitize, Event, 3, 0
	;
	; turn off "Start" button and View/Edit button
	;
	P5_button_sensitize, Event, 1, 0
	P5_button_sensitize, Event, 0, 0
	;
	night_desig_text = STRING(format='(i8.8)',(*n_ptr).night_desig)
	;
	;	clear plot window
	;
	WSET, (*s_ptr).P5_draw_window_id
	ERASE
	;
	n_bpms = (*b_ptr).bpm_n_BPM
	;
	;	check multiple status. If set to single, then reset n_bpms to unity
	;
	if( (*b_ptr).bpm_multi_mode eq 0) then begin
		MSP_BDP_print_text, Event, "Reseting n_bpms = 1 for single BPM mode"
		n_bpms = 1
	endif
	;
	;print, "number of BPMs to compute = ",n_bpms
	;
	;	reset the LED stack
	;
	P5_LED_sensitize, Event, 0, 1
	(*s_ptr).P5_LED_colors[*] = "black"
	n_LED = N_ELEMENTS( (*s_ptr).P5_LED_colors )
	;
	;print, "n_LED = ",n_LED
	;
	LED_scale = float(n_bpms) / float(n_LED)
	if(LED_scale lt 1.0) then LED_scale = 1.0
	(*b_ptr).LED_scale = LED_scale
	(*s_ptr).P5_LED_colors[0:( (n_bpms-1) < (n_LED-1))] = "gray"
	WCT_LED_stack, (*s_ptr).P5_LED_wid[0], (*s_ptr).P5_LED_colors
	;
	;WIDGET_CONTROL, /HOURGLASS
	;
	;  point to the first BPM
	;
	(*b_ptr).this_BPM_no = 0
	(*b_ptr).this_LED = 0
	;
	;	and set the number to do
	;
	(*b_ptr).bpm_n_BPM = n_bpms
	;
	;	if not "never", then make and plot the first image's histogram
	;
	if( NOT(*b_ptr).bpm_radio_flags[0]) then begin
		P5_Build_Histogram, Event
		goto, P5_SBC_end
	endif
	;
	;	this calls the "never" loop
	;
	P5_BPM_Make_Histo_Plot_Loop, Event
	MSP_BDP_print_text, Event, "All Bad Pixel Masks have been made."
	;
	;	or come here to do more with the "C" command
	;	for "first" or "every"
	;
	P5_SBC_end:
	;
end
;
;----------------------------------------------------------
;
pro P5_BPM_Make_Histo_Plot_Loop, Event
	;
	;	makes BPM based on current index
	;
	;	then checkes of more are needed before
	;	issuing Histo make command
	;
	;	if this is "first" or "never" type, will loop on
	;	Make->Histo until done
	;
	;	for "each", does not loop
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	b_ptr = PTR_struct.PTR_BPM
	s_ptr = PTR_struct.PTR_summary
	;
	;	get this_BPM pointer
	;
	this_BPM = (*b_ptr).this_BPM_no
	;
	;	recompute and save this_LED index
	;
	this_LED = ROUND(float(this_BPM) / (*b_ptr).LED_scale)
	this_LED = (0 > this_LED) < (N_ELEMENTS( (*s_ptr).P5_LED_colors) -1)
	(*b_ptr).this_LED = this_LED
	;
	P5_Compute_BPM, Event
	;
	(*b_ptr).this_BPM_no++
	if( (*b_ptr).this_BPM_no ge (*b_ptr).bpm_n_BPM) then goto, P5_end
	this_LED = ROUND(float((*b_ptr).this_BPM_no) / (*b_ptr).LED_scale)
	this_LED = (0 > this_LED) < (N_ELEMENTS( (*s_ptr).P5_LED_colors) -1)
	(*b_ptr).this_LED = this_LED
	;
	;	next histo to make, if "each" then quit
	;
	if( (*b_ptr).bpm_radio_flags[2]) then begin
		P5_Build_Histogram, Event
		goto, P5_return
	endif
	;
	;	otherwise, start the loop
	;
	P5_Compute_BPM, Event
	;
	(*b_ptr).this_BPM_no++
	if( (*b_ptr).this_BPM_no ge (*b_ptr).bpm_n_BPM) then goto, P5_end
	this_LED = ROUND(float((*b_ptr).this_BPM_no) / (*b_ptr).LED_scale)
	this_LED = (0 > this_LED) < (N_ELEMENTS( (*s_ptr).P5_LED_colors) -1)
	(*b_ptr).this_LED = this_LED
	;
	i_start = (*b_ptr).this_BPM_no
	i_end = (*b_ptr).bpm_n_BPM-1
	for i_bpm = i_start, i_end do begin
		P5_Compute_BPM, Event
		(*b_ptr).this_BPM_no++
		this_LED = ROUND(float((*b_ptr).this_BPM_no) / (*b_ptr).LED_scale)
		this_LED = (0 > this_LED) < (N_ELEMENTS( (*s_ptr).P5_LED_colors) -1)
		(*b_ptr).this_LED = this_LED
	endfor
	;
	;	loop done, so all images done, so the night summary thing
	;
	P5_end:
	P5_Save_Night_Summary, Event
	;
	;	or come here if "each" and it is time to wait for another "C" command
	;
	P5_return:
end
;-----------------------------------------------------------------
pro P5_Save_Night_Summary, Event
	;
	;	saves an updated night summary
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	n_ptr = PTR_struct.PTR_night
	k_ptr = PTR_struct.PTR_kokopeli
	s_ptr = PTR_struct.PTR_summary
	r_ptr = PTR_struct.PTR_RAW1
	b_ptr = PTR_struct.PTR_BPM
	;
	this_night = (*n_ptr).night_desig
	;
	;	which one in the summary?
	;
	num_nights = (*s_ptr).num_nights
	ind = WHERE(this_night eq (*s_ptr).night_date[0:num_nights-1], count)
	if(count ne 0) then night_index = ind[0] else begin
		MSP_BDP_print_text, Event, "Error - No matching night in P5..."
		goto, P5SNS_end
	endelse
	;
	(*s_ptr).night_who[night_index] = (*s_ptr).who
	(*s_ptr).night_step[night_index] = 5
	text = STRTRIM(STRING(format='(i)',(*b_ptr).bpm_n_BPM),2)+" BPMs Made"
	(*s_ptr).night_comment[night_index] = text
	;
	P1_Write_Summary_File, Event
	;
	P5_Draw_Done, Event, TEXT=text
	P5SNS_end:
end
;
;--------------------------------------
pro P5_Draw_Done, Event, TEXT=text
	;
	;	clears draw space and writes "Done !" in center
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	n_ptr = PTR_struct.PTR_night
	k_ptr = PTR_struct.PTR_kokopeli
	s_ptr = PTR_struct.PTR_summary
	r_ptr = PTR_struct.PTR_RAW1
	b_ptr = PTR_struct.PTR_BPM
	;
	WSET, (*s_ptr).P5_draw_window_id
	ERASE
	;
	device, decomposed=0
	color_red = REFORM((*r_ptr).color_rgb[0,*])
	color_green = REFORM((*r_ptr).color_rgb[1,*])
	color_blue = REFORM((*r_ptr).color_rgb[2,*])
	;
	tvlct, color_red, color_green, color_blue, 0
	;
	window_id = (*s_ptr).P5_draw_window_id
	;
	WSET, window_id
	;
	x = [0., 1.]
	y = [0., 1.]
	;
	plot, x, y, color=0, xrange=[0.,1.], yrange=[0.,1.], xstyle=1, ystyle=1, $
				background=0, thick=1, LINESTYLE=0, $
				POSITION=(*b_ptr).position,/DEVICE,/NODATA
	;
	XYoutS, 0.5, 0.5, "Done !", ALIGNMENT=0.5, color=2, charthick=2, charsize=4.0
	;
	nt = N_ELEMENTS(TEXT)
	if(nt eq 1) then XYoutS, 0.5, 0.25, text, ALIGNMENT=0.5, color=2, charthick=2, charsize=4.0
	;
	P5_base_sensitize, Event, 2, 0
end
