pro Update_FITS_Header_from_Group_Table, Event, pathname, filt_type, group_number
	;
	;	opens a FITS file, updates important header variables
	;	that may have been edited during the group table (Step 2) process
	;
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	s_ptr = PTR_struct.PTR_summary
	filt_ptr = PTR_struct.PTR_filt
	n_ptr = PTR_struct.PTR_night
	;
	;	verify that obs_type matches known type
	;
	ind = WHERE(filt_type eq (*filt_ptr).types[*].Name, count)
	if(count ne 1) then begin
		MSP_BDP_print_text, Event, "Error in Test_Fix_Bad_Filter_Names - count = "+STRING(format='(i)',count)
		goto, the_end
	endif
	;
	;	ok, ind points to correct image type
	;
	ind = ind[0]
	;
	image = readfits(pathname, header, /silent)
	;
	; rewrite all filter names (but not positions)
	;
	for i_filt = 0, 3 do begin
		FXADDPAR, header, 'FILTNME'+STRING(format='(I1)',i_filt+1), $
				(*filt_ptr).types[ind].FW[i_filt,0], "Written by MSP_BDP"
				;
		;print, "fixing filter ",i_filt+1,' name - now = ',(*filt_ptr).types[ind].FW[i_filt,0]
		;
	endfor
	;
	;	and other key words
	;
	group_number = group_number
	;
	MSP_BDP_Query_Group_Info, Event, group_number, $
		filter, obs_type, camera, HWP_angle, ut, exptime, $
		date_obs, jd
	;
	FXADDPAR, header, "MSP

	FXADDPAR, input_header, "MB_ITYPE", (*n_ptr).image_type[k], "MSP-BDP Image Type"
	FXADDPAR, input_header, "MB_FILTR", (*n_ptr).image_filter[k],"MSP-BDP Image Filter Type"
	FXADDPAR, input_header, "MB_FRAME", (*n_ptr).image_frame[k],"MSP-BDP Subframe or Full mode"
	FXADDPAR, input_header, "MB_HWP",   (*n_ptr).image_HWP_angle[k],"MSP-BDP HWP Angle in degrees"
	FXADDPAR, input_header, "MB_SKJMP", (*n_ptr).image_ski_jump[k],"MSP-BDP Ski Jump Type"
	FXADDPAR, input_header, "MB_CAMRA", (*n_ptr).image_camera[k],"MSP-BDP Camera Type"
	FXADDPAR, input_header, "MB_RDMOD", (*n_ptr).image_readout_mode[k],"MSP-BDP Readout Mode"
	;
	;	rewrite image
	;
	writefits, pathname, image, header, /silent
	;
	the_end:
end