function get_CDS_pathname, Event, image_index
;
;	returns the full pathname to a CDS file, given the
;	image index
;
;	assumes the night's files are already loaded
;
WIDGET_CONTROL, Event.top, GET_UVALUE = PTR_struct
n_ptr = PTR_struct.PTR_night
s_ptr = PTR_struct.PTR_summary
;
night_desig_text = STRTRIM(STRING(format='(I8.8)',(*n_ptr).night_desig),2)
;
;	get image number, and create full pathname
;
image_no = (*n_ptr).image_list[image_index]
image_no_text = STRTRIM(STRING(format='(i5.3)',image_no),2)
;
;	convert to CDS image name
;
CDS_name = night_desig_text + '.' + image_no_text + '.fits'
;
dir_index = (*n_ptr).image_root_index[image_index]
;
if(dir_index eq 0) then begin
	base_dir = (*s_ptr).root_raw
endif else begin
	base_dir = (*s_ptr).root_reduced
endelse
;
;	recover CDS directory
;
CDS_dir = base_dir + (*n_ptr).paths_cds_root[dir_index]
;RAW1_dir = (*n_ptr).paths_raw1_root[dir_index]
;
;	form full pathname to CDS file
;
path = fix_path( FILEPATH(CDS_name, ROOT_DIR=CDS_dir) )
;
return, path
end