function get_RAW1_pathname, Event, image_index
;
;	returns the full pathname to a RAW1 file, given the
;	image index
;
;	assumes the night's files are already loaded
;
WIDGET_CONTROL, Event.top, GET_UVALUE = PTR_struct
n_ptr = PTR_struct.PTR_night
s_ptr = PTR_struct.PTR_summary
;
;	get image number, and create full pathname
;
image_no = (*n_ptr).image_list[image_index]
image_no_text = STRTRIM(STRING(format='(i5.3)',image_no),2)
;
;	convert to RAW1 image name
;
RAW1_name = 'raw1_' + image_no_text
;
dir_index = (*n_ptr).image_root_index[image_index]
;
if(dir_index eq 0) then begin
	base_dir = (*s_ptr).root_raw
endif else begin
	base_dir = (*s_ptr).root_reduced
endelse
;
;	recover RAW1 directory
;
RAW1_dir = base_dir + (*n_ptr).paths_raw1_root[dir_index]
;
;	form full pathname to RAW1 file
;
path = fix_path( FILEPATH(RAW1_name, ROOT_DIR=RAW1_dir) )
;
return, path
end