function kokepeli_gaussian_fit, vector, index_max, value_max
;
;   does a gaussian fit to the column vector,
;   with initial guesses of center = index_max,
;   peak (as found), background = mean, and
;   width = 2
;
;   DPC 20050621 initial code
;       20050726 modified to use convolved image data with positive signals
;
;print, "Index_max = ",index_max
mean = median_filtered_mean(vector)
;
pos_vector = vector - mean[0];   * turned around for new image data ** mean[0] - vector   ; zeros and flip to make a peak
;print, "mean = ",mean[0]
;print, "pos_vector = "
;print, format="(21(i7,1x))",pos_vector
;
gz = fltarr(4)
gz[3] = total(pos_vector[0:5])/6.
gz[0] = pos_vector[index_max] - gz[3]
gz[1] = index_max
gz[2] = 0.8

a = fltarr(4)
x = indgen(21)
y = pos_vector
result = fltarr(21)
;
Result = GAUSSFIT( X, Y , A, ESTIMATES=gz, NTERMS=4, SIGMA=sfit, STATUS=status)
;
;print, "Gaussian fit results"
;print, "  Center = ",a[1]," +/- ",sfit[1]
;print, "  Width  = ",a[2]," +/- ",sfit[2]
;print, "  Backgnd= ",a[3]," +/- ",sfit[3]
;
;   pack center, uncertainty into short vector
;
;     if the error is huge, or the value is out of bounds,
;     reset to the starting guess for value and set uncertainty large
;
if(a[1] gt 21 or a[1] lt 0) then begin
    a[1] = index_max
    sfit[1] = 2.
endif
;
gsz = fltarr(2)
gsz[0] = a[1]
gsz[1] = 2. < sfit[1]
;
return, gsz
end

