function read_raw1, inpath, ncol, nrow
;
;   reads RAW1 type images, including byteswapping
;   if needed (windows machines)
;
;   if the ncol, nrow arguments are present, subframing
;     taking place
;
;
;   DPC   20070401  modified to read OS family and turn off byteswapping for UNIX
;		  20130920  modified to read I*64 coadded RAW1 files
;
nargs = N_PARAMS()
if(nargs eq 1) then begin
    ncol = 1024
    nrow = 1026
endif
iok = FILE_TEST(inpath)
if(iok ne 1) then begin
    print, "File ",inpath," does not exist"
    stop
endif
openr, lu_read, inpath, /GET_LUN
;
;	compare byte count for I*2 and I*4
;
i2 = long(ncol) * long(nrow) * long(2)
i4 = i2 * long(2)
;
test = FILE_INFO(inpath)
;
;	if within 10% of one or the other of i2, i4 select that mode
;
if( abs(i2 - test.size) lt 0.1*i2 ) then begin
	;
	;	I*2 is unsigned
	;
	image = uintarr(ncol,nrow)
	type_i2 = 1
endif else type_i2 = 0
;
if( abs(i4 - test.size) lt 0.1*i4 ) then begin
	;
	;	I*4 is signed
	;
	image = lonarr(ncol,nrow)
	type_i4 = 1
endif else type_i4 = 0
;
tc = 0L
readu, lu_read, image, TRANSFER_COUNT=tc
;
;print, "Pixels Transferred = ",tc
;
;print, image[100,100],format='("(100,100) pixel bytes = ",B)'
;OSF = STRUPCASE(!VERSION.OS_FAMILY)
;if(OSF eq "WINDOWS") then begin
if(type_i2 eq 1) then begin
	byteorder, image, /SWAP_IF_LITTLE_ENDIAN
endif
if(type_i4 eq 1) then begin
	byteorder, image, /LSWAP
endif
;
if(type_i2 eq 1) then image = long(image)
FREE_LUN, lu_read
;
return, image
end